package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import com.javaseleniumtemplate.flows.LiberacaoDeCardapioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.openqa.selenium.By;
import org.testng.annotations.Test;

public class LiberacaoDeCardapioPage extends PageBase {

    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Liberação de Cardápio para Unidades']");
    By clicaCampoAgrupamento = By.xpath("//div[@id = 'NMGRUPFILI']/input");
    By filtroUnidade = By.xpath("//div[@id = 'NMFILIAL']");
    By informaBusca = By.xpath("//*[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By lupaFiltro = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By selecionaAgrupamento = By.xpath("//span[text() = '0000000002 | MATERIA PRIMA - MATERIAL DE EMBALAGEM']");
    By selecionaFilial = By.xpath("//section[@data-zh-id='9999']//div[@class = 'header']//div[@data-zh-field-name='__CHECKBOX']");
    By btnOk = By.xpath("//div[@id = 'footer']//span[text() = 'Ok']");
    By todasUnidades = By.xpath("//label[@for = 'zh-checkbox-ALL_CDFILIAL']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By todosServicos = By.xpath("//label[@for = 'zh-checkbox-ALL_CDSERVFILI']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By filtroServico = By.xpath("//div[@name = 'NMSERVICO']");
    By selecionaServicosUnidade = By.xpath("//*[@id='grid-9999']/div[1]/div/div/div[1]");
    By filtroCardapio = By.xpath("//div[@name = 'DTMESCARD']");
    By mesCardapio = By.xpath("//div[@class = 'month']//div[text() = 'Dez']");
    By btnAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro']");
    By checkBoxLiberaServico = By.xpath("//div[@class = 'tr cell1']//div[@data-zh-field-name='__CHECKBOX']");
    By btnAcoes = By.xpath("//span[text() = 'Ações']");
    By btnLiberarCardapio = By.xpath("//span[text() = 'Liberar Cardápio']");
    By btnCancelarLiberacao = By.xpath("//span[text() = 'Cancelar Liberação']");
    By btnRelatorio = By.xpath("//span[text() = 'Relatório']");
    By confirmaLiberacao = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Sim']");
    By cancelaLiberacao = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Sim']");
    By confirmaMensagem = By.xpath("//button[@class = 'zh-alert-button']");
    By checkBoxSelecionaTodos = By.xpath("//div[@class = 'header-content']//div[@data-ng-if='widget.showCheckbox']");
    By abreTelaFiltro = By.xpath("//div[@class = 'control-info']//span[@data-zh-icon='filter no-border icon-white']");
    By retornaDataHoraAprovacao = By.xpath("//*[@id='grid-948523070128282165284']/div[2]/div/div[1]/div[6]");

    //Envio de e-mail
    By mailDestinatario = By.xpath("//div[@id = 'mailRecipient']");
    By selecionaDestinatario = By.xpath("//section[@class = 'popup-content']//div[@class = 'th grid-checkbox-column fixed']");
    By mailAssunto = By.xpath("//input[@id = 'mailSubject']");
    By mailMensagem = By.xpath("//textarea[@id = 'mailBody']");
    By btnEnviar = By.xpath("//section[@class = 'popup-container popup-modal']//li[@data-zh-id='948523070840237774331']");
    By btnCancelar = By.xpath("//section[@class = 'popup-container popup-modal']//li[@data-zh-id='948523070495670371329']");

    //Ações para emitir relatório
    By checkBoxTodosOperadores = By.xpath("//label[@for = 'zh-checkbox-ALL_NMOPERADOR']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By btnCalendarioRelatorio = By.xpath("//div[@id = 'DATACARDAPIO']//span[@class = 'zh-icon zh-icon-calendar zh-icon-no-border']");
    By mesEmissaoHistorico = By.xpath("//div[@class = 'calendar']//div[text() = 'Abr']");
    By btnGerarRelatorio = By.xpath("//div[@id = 'footer']//span[text() = 'Gerar Relatório']");
    By btnConfirmarEmissao = By.xpath("//div[@id = 'footer']//span[text() = 'Confirmar']");
    By btnCancelarRelatorio = By.xpath("//li[@data-zh-id='948523070453918895734']//span[text() = 'Cancelar']");
    By ckeckBoxTodasUnidadesRel = By.xpath("//label[@for = 'zh-checkbox-ALL_CDFILIAL']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoUnidadeRel = By.xpath("//div[@id = 'NMFILIAL']");
    By checkMarcaTodos = By.xpath("//div[@id= 'grid-9999']//div[@class = 'th grid-checkbox-column fixed']");
    By btnOkFiltrosRel = By.xpath("//section[@class ='popup-container']//div[@id = 'footer']//span[text() = 'Ok']");
    By checkBoxTodosServicosRel = By.xpath("//label[@for = 'zh-checkbox-ALL_CDSERVFILI']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoServicosRel = By.xpath("//div[@id ='NMSERVICO']");
    By checkBoxTodosOperadoresRel = By.xpath("//label[@for = 'zh-checkbox-ALL_NMOPERADOR']//div[@class = 'zh-box mousetrap zh-ripple-effect']");

    public void acessarTelaLiberacao(){
        waitForElement(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        click(pesquisaTela);
        clearAndSendKeys(pesquisaTela,"Liberação de Cardápio para Unidades");
        tempo();
        click(selecionaTela);
        tempo();

    }
    public void realizaFiltro() {
        click(filtroUnidade);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaBusca);
        clearAndSendKeys(informaBusca,"0002");
        tempo();
        click(selecionaFilial);
        click(btnOk);
        tempo();
        click(todosServicos);
        click(filtroServico);
        tempo();
        click(selecionaServicosUnidade);
        click(btnOk);
        tempo();
        click(filtroCardapio);
        tempo();
        click(mesCardapio);
        tempo();
        click(btnAplicarFiltro);
        tempo();
    }
    public void liberaCardapio(){
        click(checkBoxLiberaServico);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnLiberarCardapio);
        tempo();
        click(confirmaLiberacao);
        tempo();
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public String validaDataHoraLiberacao(){
        return getText(retornaDataHoraAprovacao);
    }

    public void enviarEmail(String acao){
        click(mailDestinatario);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaBusca);
        clearAndSendKeys(informaBusca,"Thiago Automação");
        tempo();
        click(selecionaDestinatario);
        click(btnOk);
        click(mailAssunto);
        clearAndSendKeys(mailAssunto, "Envio de e-mail Teste de Aprovação de Cardápio");
        click(mailMensagem);
        if (acao == "Liberar") {
            clearAndSendKeys(mailMensagem, "Liberação de cardápio unidade automação!!");
        }else {
            clearAndSendKeys(mailMensagem, "Cancelamento de cardápio unidade automação!!");
        }
        tempo();
        click(btnEnviar);
        tempo();
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public void cancelaLiberacao(){
        click(checkBoxLiberaServico);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnCancelarLiberacao);
        tempo();
        click(cancelaLiberacao);
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public void filtroTodos(){
        tempo();
        click(clicaCampoAgrupamento);
        tempo();
        click(selecionaAgrupamento);
        tempo();
        click(todasUnidades);
        tempo();
        click(filtroCardapio);
        tempo();
        click(mesCardapio);
        tempo();
        click(btnAplicarFiltro);
        tempo();
    }
    public void liberaTodosCardapios(){
        click(checkBoxSelecionaTodos);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnLiberarCardapio);
        tempo();
        click(confirmaLiberacao);
        tempo();
        tempo();
        click(confirmaMensagem);
        tempo();
    }
    public void cancelaTodosCardapios(){
        click(checkBoxSelecionaTodos);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnCancelarLiberacao);
        tempo();
        click(cancelaLiberacao);
        tempo();
        tempo();
        click(confirmaMensagem);
        tempo();
    }
    public void emiteRelatorioHistorico(){
        click(btnRelatorio);
        tempo();
        click(btnCalendarioRelatorio);
        tempo();
        click(mesEmissaoHistorico);
        click(btnGerarRelatorio);
        tempo();
        click(btnConfirmarEmissao);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        click(ckeckBoxTodasUnidadesRel);
        tempo();
        click(campoUnidadeRel);
        tempo();
        click(checkMarcaTodos);
        tempo();
        click(btnOkFiltrosRel);
        tempo();
        click(checkBoxTodosServicosRel);
        tempo();
        click(campoServicosRel);
        tempo();
        click(checkMarcaTodos);
        tempo();
        click(btnOkFiltrosRel);
        tempo();
        click(btnGerarRelatorio);
        tempo();
        click(btnConfirmarEmissao);
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(btnCancelarRelatorio);
        tempo();

    }

}
