package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class PadraoServicoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaPadraoServico = By.xpath("//span[text() = 'Padrão de Serviço']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");
    By botaoDeOpcoesDaTela = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisar = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurarProduto = By.xpath("//section[@class=\"popup-content\"]//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By campoProcurarTelaInicial = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");
    By botaoEditar = By.xpath("//div[@class=\"zh-footer-center\"]//li[1]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//li[2]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoExcluirSelecionados = By.xpath("//div[@class=\"zh-footer-center\"]//li");

    By campoCodigo = By.id("CDSERVPADR");
    By campoNomeAddPadrao = By.xpath("//input[@id=\"NMSERVPADR\"]");
    By botaoCampoProduto = By.xpath("//div[@id=\"NMPRODUTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By produtoCarbonatoDeBario = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CARBONATO DE BARIO']");
    By produtoCloeretoDeSodio = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CLORETO DE SODIO']");
    By produtoOxidoDeArsenio = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'OXIDO DE ARSENIO']");
    By produtoBoratoDeSodio = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'BORATO DE SODIO 1 KG']");

    By checkBoxPadraoServicoAdicionado1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By botaoEditarPadraoServicoAdicionado1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__LEFT_ACTIONS\"]//div[@class=\"zh-grid-actions\"]/span[1]");
    By botaoExcluirPadraoServicoAdicionado1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__LEFT_ACTIONS\"]//div[@class=\"zh-grid-actions\"]/span[2]");
    By codigoPadraoServicoAdicionado1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDSERVPADR\"]/span");
    By nomePadraoServicoAdicionado1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMSERVPADR\"]/span");
    By codigoProdutoPadraoServicoAdicionado1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoPadraoServicoAdicionado1 = By.xpath("//div[@class=\"container zh-grid-container\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");

    By mensagemObrigatorioCodigo = By.xpath("//div[@data-zh-id=\"1140062044072238888401\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNome = By.xpath("//div[@data-zh-id=\"1140062042721182512403\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProduto = By.xpath("//div[@data-zh-id=\"1140062041640939118404\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNomeProduto = By.xpath("//div[@data-zh-id=\"1140062042801133768405\"]//div[@class=\"zh-validation\"]/span");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Padrão de Serviço");
        click(opcaoTelaPadraoServico);
    }

    public void addPadraoServico() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionar);
        tempo();
        tempo();
        sendKeys(campoCodigo, "4");
        sendKeys(campoNomeAddPadrao, "DISTRIBUIÇÃO");
        click(botaoCampoProduto);
        sendKeys(campoProcurarProduto, "101110200700");
        tempo();
        tempo();
        click(produtoCarbonatoDeBario);
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
    }

    public void verificarPadraoServicoAdd() {
        preencherCampoProcurarTelaInicial("00004");

        //valores esperados
        String expCodigoPadraoServico = "00004";
        String expNomePadraoServico = "DISTRIBUIÇÃO";
        String expCodigoProduto = "1.01.1.1.02.007.00";
        String expNomeProduto = "CARBONATO DE BARIO";

        //valores encontrados
        String encCodigoPadraoServico = getText(codigoPadraoServicoAdicionado1);
        String encNomePadraoServico = getText(nomePadraoServicoAdicionado1);
        String encCodigoProduto = getText(codigoProdutoPadraoServicoAdicionado1);
        String encNomeProduto = getText(nomeProdutoPadraoServicoAdicionado1);

        Assert.assertEquals(encCodigoPadraoServico, expCodigoPadraoServico, "Verificar 'código' do padrão de serviço adicionado");
        Assert.assertEquals(encNomePadraoServico, expNomePadraoServico, "Verificar 'nome' do padrão de serviço adicionado");
        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificar 'código do produto' do padrão de serviço adicionado");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar 'nome do produto' do padrão de serviço adicionado");
    }

    public void adicionarSegundoPadraoDeServico() {
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "5");
        sendKeys(campoNomeAddPadrao, "RECEBIMENTOS ATRASADOS");
        click(botaoCampoProduto);
        sendKeys(campoProcurarProduto, "101120200301");
        click(produtoBoratoDeSodio);
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
    }

    public void editarAcessandoPadraoServico() {
        preencherCampoProcurarTelaInicial("00003");
        click(codigoPadraoServicoAdicionado1);
        click(botaoEditar);
        tempo();
        editarPadraoServico();
    }

    public void excluirPadraoServico() {
        preencherCampoProcurarTelaInicial("00004");
        click(codigoProdutoPadraoServicoAdicionado1);
        tempo();
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o registro?\n00004 - DISTRIBUIÇÃO";
        Assert.assertEquals(mensagem, mensagemEsperada, "Excluir padrão serviço adicionado");
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();
    }


    public void editarPadraoServicoBotaoTelaInicial() {
        preencherCampoProcurarTelaInicial("00003");
        click(botaoEditarPadraoServicoAdicionado1);
        editarPadraoServico();
    }

    public void excluirPadraoServicoBotaoTelaInicial() {
        preencherCampoProcurarTelaInicial("00004");
        click(botaoExcluirPadraoServicoAdicionado1);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o registro?\n00004 - DISTRIBUIÇÃO";

        Assert.assertEquals(mensagem, mensagemEsperada, "Excluir padrão serviço adicionado");
        click(botaoSim);
        tempo();
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();
    }

    public void excluirPadroesServicosSelecionados() {
        List<String> codigosDePesquisa = new ArrayList<>();
        codigosDePesquisa.add("00004");
        codigosDePesquisa.add("00005");
        selecionarAlgunsCheckBox(codigosDePesquisa);
        click(botaoExcluirSelecionados);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após excluir após selecionar mais de um padrão de serviço");
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();
    }

    public void alterarNomePadraoServico() {
        preencherCampoProcurarTelaInicial("00002");
        editarNomeNaTelaInicial("RECEBIMENTO");
        editarNomeNaTelaInicial("RECEBER");
    }

    public void registroJaExiste() {
        tempo();
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "1");
        sendKeys(campoNomeAddPadrao, "PESQUISAS");
        tempo();
        click(botaoCampoProduto);
        sendKeys(campoProcurarProduto, "101120200301");
        tempo();
        click(produtoBoratoDeSodio);
        click(botaoSalvar);
        verificarMensagemImpossivelAddRegistroJaExiste();
        click(botaoCancelar);
    }

    public void camposObrigatorios() {
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String codigo = getText(mensagemObrigatorioCodigo);
        String nome = getText(mensagemObrigatorioNome);
        String produto = getText(mensagemObrigatorioProduto);
        String nomeProduto = getText(mensagemObrigatorioNomeProduto);
        String mensagemEsperada = "Campo obrigatório";

        Assert.assertEquals(codigo, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'código'");
        Assert.assertEquals(nome, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'nome'");
        Assert.assertEquals(produto, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'produto'");
        Assert.assertEquals(nomeProduto, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'nome produto'");
        click(botaoCancelar);
    }

    public void tentarSalvarEdicaoCampoNomeVazio() {
        preencherCampoProcurarTelaInicial("00002");
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(nomePadraoServicoAdicionado1)).click();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(" ").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        click(botaoSalvarAlteracoes);

        String mensagemEsperada = "Informe o nome para o(s) registro(s) editado(s).";
        String mensagem = getText(mensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela ao tentar salvar a edição com o campo nome vazio");
        click(botaoOk);
        click(botaoCancelar);

        String encNome = getText(nomePadraoServicoAdicionado1);
        String expNome = "RECEBER";
        Assert.assertEquals(encNome, expNome, "Verificar se ao cancelar a edição do nome, o nome salvo anteriormente não foi alterado");
    }

    private void editarPadraoServico() {
        boolean encCampoCodigo = returnIfElementIsEnabled(campoCodigo);
        boolean expCampoCodigo = false;
        Assert.assertEquals(encCampoCodigo, expCampoCodigo, "Verificar se no momento da edição o campo 'código' do padrão de serviço está desabiliado");

        clearAndSendKeys(campoNomeAddPadrao, "ANALISE");
        click(botaoCampoProduto);
        click(botaoCampoProduto);
        tempo();
        sendKeys(campoProcurarProduto, "101110201000");
        click(produtoCloeretoDeSodio);
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();

        //valores esperados
        String expCodigoPadraoServico = "00003";
        String expNomePadraoServico = "ANALISE";
        String expCodigoProduto = "1.01.1.1.02.010.00";
        String expNomeProduto = "CLORETO DE SODIO";

        //valores encontrados
        String encCodigoPadraoServico = getText(codigoPadraoServicoAdicionado1);
        String encNomePadraoServico = getText(nomePadraoServicoAdicionado1);
        String encCodigoProduto = getText(codigoProdutoPadraoServicoAdicionado1);
        String encNomeProduto = getText(nomeProdutoPadraoServicoAdicionado1);

        Assert.assertEquals(encCodigoPadraoServico, expCodigoPadraoServico, "Verificar 'código' do padrão de serviço após a edição");
        Assert.assertEquals(encNomePadraoServico, expNomePadraoServico, "Verificar 'nome' do padrão de serviço após a edição");
        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificar 'código do produto' do padrão de serviço após a edição");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar 'nome do produto' do padrão de serviço após a edição ");

        click(codigoPadraoServicoAdicionado1);
        click(botaoEditar);
        clearAndSendKeys(campoNomeAddPadrao, "PESQUISA");
        click(botaoCampoProduto);
        click(botaoCampoProduto);
        tempo();
        sendKeys(campoProcurarProduto, "101110202001");
        click(produtoOxidoDeArsenio);
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
    }

    private void editarNomeNaTelaInicial(String nomePadraoServico) {
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(nomePadraoServicoAdicionado1)).click();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(nomePadraoServico).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
        click(botaoSalvarAlteracoes);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();

        tempo();
        String encNomePadraoServico = getText(nomePadraoServicoAdicionado1);
        Assert.assertEquals(encNomePadraoServico, nomePadraoServico, "Verificar nome do padrão de serviço após o mesmo ser alterado pelo campo na tela inicial");
    }

    private void selecionarAlgunsCheckBox(List<String> codigosDePesquisa) {
        for (String codigo : codigosDePesquisa) {
            preencherCampoProcurarTelaInicial(codigo);
            click(checkBoxPadraoServicoAdicionado1);
        }
        clear(campoProcurarTelaInicial);
        tempo();
    }

    private void verificarMensagemSalvoSucessoNoCantoSuperiorDireito() {
        String mensagemExcluidoSucesso = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagemExcluidoSucesso, "Salvo com sucesso.", "Verificação da mensagem de excluído om sucesso, após a exclusão do grupo");
    }

    private void verificarMensagemExcluidoSucessoNoCantoSuperiorDireito() {
        String mensagemExcluidoSucesso = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagemExcluidoSucesso, "Excluído com sucesso.", "Verificação da mensagem de excluído om sucesso, após a exclusão do grupo");
    }

    private void verificarMensagemImpossivelAddRegistroJaExiste() {
        String mensagemExcluidoSucesso = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagemExcluidoSucesso, "Impossível adicionar. Registro já existe.", "Verificação da mensagem de excluído om sucesso, após a exclusão do grupo");
    }


    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoDeOpcoesDaTela) && !returnClassOpened(botaoPesquisar)) {
            click(botaoPesquisar);
        } else if (!returnClassOpened(botaoDeOpcoesDaTela)){
            click(botaoDeOpcoesDaTela);
            click(botaoPesquisar);
        }
        clearAndSendKeys(campoProcurarTelaInicial, texto);
        tempo();
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}
