package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.AlergenicoFlows;
import com.javaseleniumtemplate.pages.AlergenicoPage;
import org.testng.annotations.Test;

public class AlergenicoTests extends TestBase {

    AlergenicoPage alergenicoPage;
    AlergenicoFlows alergenicoFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Alergênico'
    //adicionar um alergênco selecionando a imagem do peixe
    //filtrar pelo nome do alergênico adicionado, acessar o mesmo, verificar se o nome, a sigla e a imagem foram salvos corretamente
    //excluir este alergênico adicionado
    @Test
    public void addExcluirAlergenico() {
        alergenicoPage = new AlergenicoPage();
        alergenicoFlows = new AlergenicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        alergenicoFlows.navegateApresentacaoProduto();
        alergenicoPage.adicionarAlergenico();
        alergenicoPage.verificarAlergenico();
        alergenicoPage.excluirAlergenico();
    }

    //acessar a tela 'Alergênico'
    //filtrar pelo alergênico 'MOSTARDA' e acessar o mesmo
    //clicar em editar
    //alterar o nome, a sigla e a imagem do alergênico
    //verificar se os valores alterados foram salvos corretamente
    //editar novamente o alergênico retornando os dados (nome, sigla e imagem) para os da mostarda que estavam no início do teste
    @Test
    public void editarAlergenico() {
        alergenicoPage = new AlergenicoPage();
        alergenicoFlows = new AlergenicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        alergenicoFlows.navegateApresentacaoProduto();
        alergenicoPage.editarAlergenico();
    }

    //acessar a tela 'Alergênico'
    //clicar no botão adicionar, clicar em salvar
    //verificar mensagem de campo obrigatório nos campos: nome e sigla
    @Test
    public void camposObrigatorios(){
        alergenicoPage = new AlergenicoPage();
        alergenicoFlows = new AlergenicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        alergenicoFlows.navegateApresentacaoProduto();
        alergenicoPage.camposObrigatorios();
    }

    //acessar a tela 'Alergênico'
    //adicionar um alergênico (com nome, sigla e sem selecionar uma imagem)
    //verificar se o nome, a sigla foram adicionados corretamente e se o ícone está com a imagem padrão da câmera
    //excluir o alergênico que foi utilizado para verificação
    @Test
    public void adicionarRemoverAlerSemImg() {
        alergenicoPage = new AlergenicoPage();
        alergenicoFlows = new AlergenicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        alergenicoFlows.navegateApresentacaoProduto();
        alergenicoPage.addSemImagem();
        alergenicoPage.excluirAlergenico();
    }

}
