package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.CadastroTipoDePratoFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.CadastroTipoDePratoPage;
import org.openqa.selenium.JavascriptExecutor;
import org.testng.Assert;
import org.testng.annotations.Test;
import org.testng.annotations.TestInstance;

public class CadastroTipoDePratoTests extends TestBase {
    CadastroTipoDePratoFlows cadastroTipoDePratoFlows;
    LoginFlows loginFlows;

    public void acessarTela(){
        String msgEsperada = "Tipo de Prato";
        loginFlows = new LoginFlows();
        cadastroTipoDePratoFlows = new CadastroTipoDePratoFlows();
        loginFlows.efetuarLogin();
        cadastroTipoDePratoFlows.navegaTipoDePrato();
        Assert.assertEquals(cadastroTipoDePratoFlows.msgEncontrada(),msgEsperada,"Validando acesso tela: ");

    }


    @Test
    public void adicionarTipoDePrato() {
        String codigo = "50";
        String nomeTipoPrato = "SALADA FRIA";
        String nomeReduzido = "SALADA";
        String nmGrupo = "Salada";
        acessarTela();
        cadastroTipoDePratoFlows.cadastraTipoPrato(codigo, nomeTipoPrato, nomeReduzido, nmGrupo);
        Assert.assertEquals(cadastroTipoDePratoFlows.msgEncontradaCadastro(),nomeTipoPrato,"Cadastro tipo prato");

    }

    @Test
    public void alterarTipoPrato(){
        String novoNome = "SALADA FRIA";
        String nomeReduzido = "SALADA";
        String cdNovoGrupo = "01";
        acessarTela();
        cadastroTipoDePratoFlows.alteraTipodePrato(novoNome,nomeReduzido,cdNovoGrupo);

    }

    @Test
    public void excluirRegistro(){
        String msgEsperada = "Excluído com sucesso.";
        acessarTela();
        cadastroTipoDePratoFlows.excluirTipoPrato();
        Assert.assertEquals(cadastroTipoDePratoFlows.msgEncontradaExclusao(),msgEsperada,"Confirmando exclusão: ");
    }

    @Test
    public void validaExclusaoRegistroRelacionado(){
        String msgCodEsperado = "07";
        acessarTela();
        cadastroTipoDePratoFlows.excluirTipoDePratoRelacionado();
        Assert.assertEquals(cadastroTipoDePratoFlows.validarExclusao(),msgCodEsperado,"Código encontrado prato: ");
    }

    @Test
    public void validarCamposObrigatorios(){
        acessarTela();
        cadastroTipoDePratoFlows.camposObrigatorios();
    }

    @Test
    public void validarCadastroRegistroExistente(){
        String codigo = "01";
        String nomeTipoPrato = "AUTOMAÇÃO";
        String nomeReduzido = "AUTOMAÇÃO";
        String nmGrupo = "PRATO PRINCIPAL";
        acessarTela();
        cadastroTipoDePratoFlows.cadastraTipoPrato(codigo, nomeTipoPrato, nomeReduzido, nmGrupo);


    }


}
