package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ConsumoPorServicoFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ConsumoPorServicoTests extends TestBase {


    ConsumoPorServicoFlows consumoporserviçoflows;
    LoginFlows loginFlows;

    public void acessarTela(String cdFilial,String tipoConsumo, String diaSemanaConsumo ){
        consumoporserviçoflows = new ConsumoPorServicoFlows();
        loginFlows = new LoginFlows();
        loginFlows.efetuarLogin();
        consumoporserviçoflows.navegarConsumoPorServico();
        consumoporserviçoflows.realizarFiltro(cdFilial,tipoConsumo,diaSemanaConsumo);
    }

    @Test
   public void adicionarConsumoPorServico(){
        String cdFilial = "0002";
        String tipoConsumo = "Fixo";
        String cozinhaCentral = "Distribuicao";
        String diaSemanaConsumo = "Terça";
        String CDPRODUTO = "101110100100";
        String QTDPRODUTO = "2";
        String NMPRODUTO = "CREOSOTO";
        String CDPRODUTO_2 = "101110100300";
        String QTDPRODUTO_2 = "10";
        String NMPRODUTO_2 = "OLEO DE COPAIBA";

        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.adicionarProduto(CDPRODUTO, QTDPRODUTO, tipoConsumo, cozinhaCentral, CDPRODUTO_2, QTDPRODUTO_2);
        Assert.assertEquals(consumoporserviçoflows.retornaMensagem(),NMPRODUTO,"Produto Creosoto: ");
        consumoporserviçoflows.adicionarNovoProduto(CDPRODUTO_2, QTDPRODUTO_2,tipoConsumo);
        Assert.assertEquals(consumoporserviçoflows.retornaMensagem_2(),NMPRODUTO_2,"Produto Óleo de Copaiba: ");
    }

    @Test
    public void editarConsumoServicoFixo(){
        String cdFilial = "0002";
        String tipoConsumo = " ";
        String diaSemanaConsumo = "Terça";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.alterarConsumoDia(tipoConsumo);
    }

    @Test
    public void excluirConsumoServico(){
        String cdFilial = "0002";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Terça";
        String msgEsperada = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.apagarConsumo();
        Assert.assertEquals(consumoporserviçoflows.mensagemExclusao(),msgEsperada,"Validando exclusão produtos: ");
    }

    @Test
    public void adicionarConsumoPorServicoPerCapita(){
        String cdFilial = "0003";
        String tipoConsumo = "Per Capita";
        String cozinhaCentral = "Distribuicao";
        String diaSemanaConsumo = "Quinta";
        String CDPRODUTO = "101110100100";
        String QTDPRODUTO = "2";
        String NMPRODUTO = "CREOSOTO";
        String CDPRODUTO_2 = "101110100300";
        String QTDPRODUTO_2 = "10";
        String NMPRODUTO_2 = "OLEO DE COPAIBA";

        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.adicionarProduto(CDPRODUTO, QTDPRODUTO, tipoConsumo, cozinhaCentral, CDPRODUTO_2, QTDPRODUTO_2);
        Assert.assertEquals(consumoporserviçoflows.retornaMensagem(),NMPRODUTO,"Produto Creosoto: ");
        consumoporserviçoflows.adicionarNovoProduto(CDPRODUTO_2, QTDPRODUTO_2,tipoConsumo);
        Assert.assertEquals(consumoporserviçoflows.retornaMensagem_2(),NMPRODUTO_2,"Produto Óleo de Copaiba: ");
    }

    @Test
    public void editarConsumoServicoPerCapita(){
        String cdFilial = "0003";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Quinta";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.alterarConsumoDia(tipoConsumo);
    }

    @Test
    public void excluirConsumoServicoPerCapita(){
        String cdFilial = "0003";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Quinta";
        String msgEsperada = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.apagarConsumo();
        Assert.assertEquals(consumoporserviçoflows.mensagemExclusao(),msgEsperada,"Validando exclusão produtos: ");
    }

    @Test
    public void adicionarExcecaoConsumo(){
        String cdFilial = "0002";
        String tipoConsumo = "Fixo";
        String tipoConsumoExcecao = "Fixo";
        String diaSemanaConsumo = "Terça";
        String CDPRODUTO = "101110100100";
        String QTDPRODUTO = "2";
        String NMPRODUTO = "CREOSOTO";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.cadastraExcecao(tipoConsumoExcecao,CDPRODUTO, QTDPRODUTO);
        Assert.assertEquals(consumoporserviçoflows.validarCadastroProdutoExecao(),NMPRODUTO,"Produto Exceção: ");
    }

    @Test
    public void editarProdutoExcecao(){
        String cdFilial = "0002";
        String tipoConsumo = "Fixo";
        String tipoConsumoExcecao = "Fixo";
        String diaSemanaConsumo = "Terça";
        String qtdAtualizada = "20,00000";
        String pontoEntrega = "Sim";
        String cozCentralDist = "Distribuição";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.editaExcecao(tipoConsumoExcecao);
       // Assert.assertEquals(consumoporserviçoflows.msgEncontradaQtdConsumida(),qtdAtualizada,"Campo Quantidade: ");
        Assert.assertEquals(consumoporserviçoflows.msgEncontradaCampoPontoEntrega(),pontoEntrega,"Campo Ponto Entrega: ");
        Assert.assertEquals(consumoporserviçoflows.msgEncontradaCozinhaCentralDistribuicao(),cozCentralDist,"Campo Quantidade: ");
    }

    @Test
    public void excluirProdutoExcecao(){
        String cdFilial = "0002";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Terça";
        String tipoConsumoExcecao = "Fixo";
        String msgEsperadaExclusao = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.apagaProdutoExcecao(tipoConsumoExcecao);
        Assert.assertEquals(consumoporserviçoflows.mensagemExclusao(),msgEsperadaExclusao,"Validando exclusão produto: ");
    }

    @Test
    public void adicionarExcecaoConsumoPerCapita(){
        String cdFilial = "9999";
        String tipoConsumo = "Per Capita";
        String tipoConsumoExcecao = "Per Capita";
        String diaSemanaConsumo = "Quarta";
        String CDPRODUTO = "101110100100";
        String QTDPRODUTO = "2";
        String NMPRODUTO = "CREOSOTO";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.cadastraExcecao(tipoConsumoExcecao,CDPRODUTO, QTDPRODUTO);
        Assert.assertEquals(consumoporserviçoflows.validarCadastroProdutoExecao(),NMPRODUTO,"Produto Exceção: ");
    }

    @Test
    public void editarProdutoExcecaoPerCapita(){
        String cdFilial = "9999";
        String tipoConsumo = "Per Capita";
        String tipoConsumoExcecao = "Per Capita";
        String diaSemanaConsumo = "Quarta";
        String qtdAtualizada = "20,00000";
        String pontoEntrega = "Sim";
        String cozCentralDist = "Distribuição";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.editaExcecao(tipoConsumoExcecao);
       // Assert.assertEquals(consumoporserviçoflows.msgEncontradaQtdConsumida(),qtdAtualizada,"Campo Quantidade: ");
        Assert.assertEquals(consumoporserviçoflows.msgEncontradaCampoPontoEntrega(),pontoEntrega,"Campo Ponto Entrega: ");
        Assert.assertEquals(consumoporserviçoflows.msgEncontradaCozinhaCentralDistribuicao(),cozCentralDist,"Campo Quantidade: ");
    }

    @Test
    public void excluirProdutoExcecaoPerCapita(){
        String cdFilial = "9999";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Quarta";
        String tipoConsumoExcecao = "Per Capita";
        String msgEsperadaExclusao = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.apagaProdutoExcecao(tipoConsumoExcecao);
        Assert.assertEquals(consumoporserviçoflows.mensagemExclusao(),msgEsperadaExclusao,"Validando exclusão produto: ");
    }

    @Test
    public void adicionarDiaSemConsumo(){
        String cdFilial = "0002";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Terça";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.cadastraDiaSemConsumo();

    }

    @Test
    public void editarDiaSemConsumo(){
        String cdFilial = "0002";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Terça";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.edicaoDiaSemConsumo();
    }

    @Test
    public void excluirDiaSemConsumo(){
        String cdFilial = "0002";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Terça";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.apagaDiaSemConsumo();

    }

    @Test
    public void adicionarDiaSemConsumoPerCapita(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Sexta";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.cadastraDiaSemConsumo();

    }

    @Test
    public void editarDiaSemConsumoPerCapita(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Sexta";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.edicaoDiaSemConsumo();
    }

    @Test
    public void excluirDiaSemConsumoPerCapita(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Sexta";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.apagaDiaSemConsumo();

    }

    @Test
    public void importarConsumoPorServico(){
        String cdFilial = "0004";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Segunda";
        String TIPOCONSUMO = "Fixo";
        String CDFILIMPOR = "0003";
        String CDSERVIMPOR = "00002";
        String IDIMPORTACAO = "A";
        String msgEsperada_1 = "1.01.1.1.02.004.00";
        String msgEsperada_2 = "1.01.1.1.02.006.00";
        String msgEsperada_3 = "1.01.1.1.01.001.00";
        String msgEsperada_4 = "2.01.1.1.02.001.00";
        String msgEsperada_5 = "2.01.1.4.02.003.00";
        String msgEsperada_6 = "2.01.1.1.02.001.00";
        String msgEsperada_7 = "1.01.1.1.01.005.00";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.importaConsumo(CDFILIMPOR,CDSERVIMPOR,TIPOCONSUMO,IDIMPORTACAO);
        Assert.assertEquals(consumoporserviçoflows.importacaoProdCanfora(),msgEsperada_1,"Produto Canfora: ");
        Assert.assertEquals(consumoporserviçoflows.importacaoProdTampa(),msgEsperada_2,"Produto Tampa: ");
        Assert.assertEquals(consumoporserviçoflows.importacaoProdTampaFrasco(),msgEsperada_3,"Produto Tampa Frasco: ");
        Assert.assertEquals(consumoporserviçoflows.importacaoProdOleo(),msgEsperada_4,"Produto Óleo: ");
    }

    @Test
    public void importarConsumoPorServicoSobrepor(){
        String cdFilial = "0004";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Segunda";
        String TIPOCONSUMO = "Fixo";
        String CDFILIMPOR = "0003";
        String CDSERVIMPOR = "00002";
        String IDIMPORTACAO = "S";
        String msgEsperada_1 = "1.01.1.1.02.006.00";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.importaConsumo(CDFILIMPOR,CDSERVIMPOR,TIPOCONSUMO,IDIMPORTACAO);
        Assert.assertEquals(consumoporserviçoflows.validandoImportacaoSobrepor(),msgEsperada_1,"Produto Canfora: ");

    }

    @Test
    public void importarConsumoPorServicoPerCapita(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Sexta";
        String TIPOCONSUMO = "Per Capita";
        String CDFILIMPOR = "0003";
        String CDSERVIMPOR = "00002";
        String IDIMPORTACAO = "A";
        String msgEsperada_1 = "1.01.1.1.01.004.00";
        String msgEsperada_2 = "2.01.1.1.02.001.00";
        String msgEsperada_3 = "2.01.1.4.02.003.00";
        String msgEsperada_4 = "1.01.1.1.01.005.00";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.importaConsumo(CDFILIMPOR,CDSERVIMPOR,TIPOCONSUMO,IDIMPORTACAO);
        Assert.assertEquals(consumoporserviçoflows.importacaoProdCanfora(),msgEsperada_1,"Produto Canfora: ");
        Assert.assertEquals(consumoporserviçoflows.importacaoProdTampa(),msgEsperada_2,"Produto Tampa: ");
        Assert.assertEquals(consumoporserviçoflows.importacaoProdTampaFrasco(),msgEsperada_3,"Produto Tampa Frasco: ");
        Assert.assertEquals(consumoporserviçoflows.importacaoProdOleo(),msgEsperada_4,"Produto Óleo: ");
    }

    @Test
    public void importarConsumoPorServicoSobreporPerCapita(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Segunda";
        String TIPOCONSUMO = "Per Capita";
        String CDFILIMPOR = "0003";
        String CDSERVIMPOR = "00002";
        String IDIMPORTACAO = "S";
        String msgEsperada_1 = "1.01.1.1.01.003.00";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.importaConsumo(CDFILIMPOR,CDSERVIMPOR,TIPOCONSUMO,IDIMPORTACAO);
        Assert.assertEquals(consumoporserviçoflows.validandoImportacaoSobrepor(),msgEsperada_1,"Produto Canfora: ");

    }

    @Test
    public void exportarConsumoServico(){
        String cdFilial = "0004";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Segunda";
        String CDFILDEST = "9999";
        String CDSERVDEST = "00004";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.exportarConsumo(CDFILDEST,CDSERVDEST);

    }

    @Test
    public void exportarConsumoServicoPerCapita(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Segunda";
        String CDFILDEST = "9999";
        String CDSERVDEST = "00004";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.exportarConsumo(CDFILDEST,CDSERVDEST);

    }

    @Test
    public void substituiProdutoConsumo(){
        String cdFilial = "0004";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Sexta";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.substituirProduto();
    }

    @Test
    public void substituiProdutoConsumoPerCapita(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Sexta";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.substituirProduto();
    }

    @Test
    public void importarConsumoFixoExcecao(){
        String cdFilial = "0004";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Sexta";
        String tipoConsumoImportacao = "Fixo";
        String dadosExistentes = "Acrescentar";
        String produtoExecao = "1.01.1.1.02.004.00";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.importarExcecao(tipoConsumoImportacao, dadosExistentes);
        Assert.assertEquals(consumoporserviçoflows.produtoImportacaoExecao(),produtoExecao,"Produto importação exceção: ");

    }

    @Test
    public void importarConsumoPerCapitaExcecao(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Sexta";
        String tipoConsumoImportacao = "Per Capita";
        String dadosExistentes = "Acrescentar";
        String produtoExecao = "1.01.1.1.02.004.00";
        String msgEsperadaExclusao = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.importarExcecao(tipoConsumoImportacao, dadosExistentes);
        Assert.assertEquals(consumoporserviçoflows.produtoImportacaoExecao(),produtoExecao,"Produto importação exceção: ");
        consumoporserviçoflows.apagaProdutoExcecao(tipoConsumo);
        Assert.assertEquals(consumoporserviçoflows.mensagemExclusao(),msgEsperadaExclusao,"Validando exclusão produto: ");
    }

    @Test
    public void importarConsumoFixoExcecaoSobrepor(){
        String cdFilial = "0004";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Sexta";
        String tipoConsumoImportacao = "Fixo";
        String dadosExistentes = "Sobrepor";
        String cdProdutoImportacao = "1.01.1.1.02.004.00";
        String msgEsperadaExclusao = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.importarExcecao(tipoConsumoImportacao, dadosExistentes);
        Assert.assertEquals(consumoporserviçoflows.retornaProdutoImportacao(),cdProdutoImportacao,"Importação Exceção: ");
        consumoporserviçoflows.apagaProdutoExcecao(tipoConsumo);
        Assert.assertEquals(consumoporserviçoflows.mensagemExclusao(),msgEsperadaExclusao,"Validando exclusão produto exceção: ");
    }

    @Test
    public void exportarConsumoFixoExcecao(){
        String cdFilial = "0003";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Sexta";
        String acaoDadosExistentes = "Acrescentar";
        String CDPRODUTO_1 = "1.01.1.1.02.010.00";
        String CDPRODUTO_2 = "1.01.1.1.01.003.00";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.exportarExcecoesConsumo(acaoDadosExistentes);
        Assert.assertEquals(consumoporserviçoflows.validaProdutoCloreto(),CDPRODUTO_1,"Produto Cloreto Sodio:" );
        Assert.assertEquals(consumoporserviçoflows.validaProdutoOleo(),CDPRODUTO_2,"Produto Óleo: " );

    }

    @Test
    public void exportarConsumoFixoExcecaoSobrePor(){
        String cdFilial = "0004";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Sexta";
        String acaoDadosExistentes = "Sobrepor";
        String cdProduto = "1.01.1.1.02.020.00";
        String msgEsperadaExclusao = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.exportarExcecoesConsumo(acaoDadosExistentes);
        Assert.assertEquals(consumoporserviçoflows.produtoExecao(),cdProduto,"Produto exceção 9999: ");
        consumoporserviçoflows.apagaProdutoExcecao(tipoConsumo);
        Assert.assertEquals(consumoporserviçoflows.mensagemExclusao(),msgEsperadaExclusao,"Validando exclusão produto exceção: ");
    }

    @Test
    public void exportarConsumoExcecaoAcrescentarPerCapita(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Sexta";
        String acaoDadosExistentes = "Acrescentar";
        String cdProduto = "1.01.1.1.02.020.00";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.exportarExcecoesConsumo(acaoDadosExistentes);
        Assert.assertEquals(consumoporserviçoflows.produtoExecao(),cdProduto,"Produto exceção 9999: ");

    }

    @Test
    public void exportarConsumoExcecaoSobreporPerCapita(){
        String cdFilial = "0004";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Sexta";
        String acaoDadosExistentes = "Sobrepor";
        String cdProduto = "1.01.1.1.01.005.00";
        String msgEsperadaExclusao = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.exportarExcecoesConsumo(acaoDadosExistentes);
        Assert.assertEquals(consumoporserviçoflows.produtoExecao(),cdProduto,"Produto exceção 9999: ");
        consumoporserviçoflows.apagaProdutoExcecao(tipoConsumo);
        Assert.assertEquals(consumoporserviçoflows.mensagemExclusao(),msgEsperadaExclusao,"Validando exclusão produto exceção: ");
    }

    @Test
    public void substituirProdutoConcumoFixoExcecao(){
        String CDPRODORIG = "101110201300";
        String CDPRODNOVO = "101110201000";
        String cdFilial = "0003";
        String tipoConsumo = "Fixo";
        String diaSemanaConsumo = "Quinta";
        String msgEsperadaExclusao = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.substituirProdutoExcecao(CDPRODNOVO,CDPRODORIG);
    }

    @Test
    public void substituirProdutoExcecaoPerCapita(){
        String CDPRODORIG = "101110201300";
        String CDPRODNOVO = "101110201000";
        String cdFilial = "0003";
        String tipoConsumo = "Per Capita";
        String diaSemanaConsumo = "Quinta";
        String msgEsperadaExclusao = "Não há registros";
        acessarTela(cdFilial,tipoConsumo,diaSemanaConsumo);
        consumoporserviçoflows.substituirProdutoExcecao(CDPRODNOVO,CDPRODORIG);
    }



}
