package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.EmissaoCardapioMesFlows;
import com.javaseleniumtemplate.pages.EmissaoCardapioMesPage;
import org.testng.annotations.Test;

public class EmissaoCardapioMesTests extends TestBase {

    EmissaoCardapioMesPage emissaoCardapioMesPage;
    EmissaoCardapioMesFlows emissaoCardapioMesFlows;
    LoginFlows loginFlows;

//    relatorioEmissaoCardapioMes = Emissão do Cardápio do Mês
//    relatorioCentralizado = Emissão do Cardápio do Mês (Centralizado)
//    relatorioInativoReceita = Cardápios com Produto Inativo na Receita
//    relatorioInativoReceitaGeral = Cardápios com Produto Inativo na Receita (Geral)
//    relatorioDezColunas = Emissão do Cardápio do Mês (10 Colunas)
//    relatorioCusto = Emissão do Cardápio do Mês (Custo)
//    relatorioCustoTipoPrato = Emissão do Cardápio do Mês (Custo Tipo de Prato)
//    relatorioPeriodoPagina = Emissão do Cardápio do Mês (Período por Página)
//    relatorioEmissaoCardapioMesAlergenico = Emissão do Cardápio do Mês (Alergênicos)


    @Test
    public void relatorioEmissaoCardapioMes() {
        gerarRelatorio("Emissão do Cardápio do Mês");
    }

    @Test
    public void relatorioCentralizado() {
        gerarRelatorio("Emissão do Cardápio do Mês (Centralizado)");
    }

    @Test
    public void relatorioInativoReceita() {
        gerarRelatorio("Cardápios com Produto Inativo na Receita");
    }

    @Test
    public void relatorioInativoReceitaGeral() {
        gerarRelatorio("Cardápios com Produto Inativo na Receita (Geral)");
    }

    @Test
    public void relatorioDezColunas() {
        gerarRelatorio("Emissão do Cardápio do Mês (10 Colunas)");
    }

    @Test
    public void relatorioCusto() {
        gerarRelatorio("Emissão do Cardápio do Mês (Custo)");
    }

    @Test
    public void relatorioCustoTipoPrato() {
        gerarRelatorio("Emissão do Cardápio do Mês (Custo Tipo de Prato)");
    }

    @Test
    public void relatorioPeriodoPagina() {
        gerarRelatorio("Emissão do Cardápio do Mês (Período por Página)");
    }

    @Test
    public void relatorioEmissaoCardapioMesAlergenico() {
        gerarRelatorio("Emissão do Cardápio do Mês (Alergênicos)");
    }




    //acessar a tela 'Emissão do Cardápio do Mês'
    //clicar no campo relatório e selecionar o relatório que foi passado o nome como parâmetros
    //caso o relatório que tenha sido passado como parâmetro seja o 'Emissão do Cardápio do Mês (Custo)' ou 'Emissão do Cardápio do Mês (Custo Tipo de Prato)'
    //por padrão uma unidade já está selecionada e o check-box todos os serviços também
    //clicar no campo tipo de custo e selecionar o 'Custo Médio Bruto Atual' e verificar o valor apresentado no campo tipo de custo
    //desta forma irá clicar em relatório, pdf e confirmar. Para verificar se estes 2 relatório são gerados com sucesso quando o check-box de todos os serviços está selecionado
    //a guia do relatório que foi gerado com sucesso será fechada, para ser selecionada a unidade Deposito Jabaquara e também alguns serviços desta unidade,
    //clicar no campo mês inicial e selecionar OUT, clicar no campo mês final e selecionar NOV. Gerar o relatório, para verificar se com alguns serviços selecionados manualmente o relatório também é gerado com sucesso e a guia do mesmo será fechada
    //caso o relatório passado como parâmetro seja algum outro com exceção dos 2 citados anteriormente, irá clicar no campo unidade agregada e selecionar MATERIA PRIMA
    //caso o relatório passado seja o 'Emissão do Cardápio do Mês (Período por Página)', irá clicar no campo tipo de custo e selecionar o 'Custo Médio Bruto Atual' e verificar o valor apresentado no campo tipo de custo
    //automaticamente o check-box todas unidades já estará selecionado e o mesmo ocorro com o check-box todos serviços. Com estes parâmetros será gerado o relatório e caso tenha sido gerado com sucesso, a guia do relatório gerado será fechada
    //após fechar a guia do relatório, irá clicar no check-box todas unidades, clicar no campo unidade, selecionar o Deposto Bc 129 e clicar em ok.
    //clicar no check-box de todos serviços, clicar no campo serviço
    //clicar no campo mês inicial e selecionar OUT, clicar no campo mês final e selecionar NOV. Gerar o relatório, para verificar se com alguns serviços e unidade selecionados manualmente, caso o relatório também seja gerado com sucesso, a guia do mesmo será fechada
    public void gerarRelatorio(String nomeRelatorio) {
        emissaoCardapioMesPage = new EmissaoCardapioMesPage();
        emissaoCardapioMesFlows = new EmissaoCardapioMesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioMesFlows.navegateTelaEmissaoCardapioMes();
        emissaoCardapioMesPage.selecionarRelatorio(nomeRelatorio);

        if (nomeRelatorio.equals("Emissão do Cardápio do Mês (Custo)") || nomeRelatorio.equals("Emissão do Cardápio do Mês (Custo Tipo de Prato)")) {
            emissaoCardapioMesPage.selecionarTipoDeCusto();
            emissaoCardapioMesPage.gerarRelatorio(); //gerar o relatório com as informações e todos os serviços da unidade Deposito Bc 129 e após a geração do relatório fechar guia do mesmo
            emissaoCardapioMesPage.selecionarUnidadeEServicosJabaquara(); //selecionar unidade Deposito Jabaquara e os serviços da mesma
        } else {
            emissaoCardapioMesPage.selecionarAgrupamento();
            if (nomeRelatorio.equals("Emissão do Cardápio do Mês (Período por Página)")) emissaoCardapioMesPage.selecionarTipoDeCusto();
            emissaoCardapioMesPage.gerarRelatorio(); //gerar o relatório com todas as informações do agrupamento selecionar e após a geração do relatório fechar guia do mesmo
            emissaoCardapioMesPage.selecionarUnidadeDepositoBc129();
            emissaoCardapioMesPage.selecionarServicos();
        }

        emissaoCardapioMesPage.selecionarMeses();
        emissaoCardapioMesPage.gerarRelatorio();
    }






    //acessar a tela 'Emissão do Cardápio do Mês'
    //no método é gerada uma lista com todos os relatórios, primeiramente um relatório será selecionado
    //na sequência será verificado se os campos(agrupamento de unidades, unidade, serviço, mês inicial, mês final, tipo de custo, imprimir mensagem,
    //imprimir nome fantasia, imprimir dias sem cardápio, imprimir, número e percentual) estão habilitados ou não
    //após concluir a verificação de um relatório com sucesso, será selecionado outro relatório e realizada a mesma verificação
    //os campos habilitados ou não, variam de uma unidade para outra, o método possui o switch case com as regras/variações do campos habilitados ou não de um relatório para outro
    @Test
    public void camposHabilitados() {
        emissaoCardapioMesPage = new EmissaoCardapioMesPage();
        emissaoCardapioMesFlows = new EmissaoCardapioMesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioMesFlows.navegateTelaEmissaoCardapioMes();
        emissaoCardapioMesPage.camposHabilitados();
    }


    //acessar a tela 'Emissão do Cardápio do Mês'
    //no método é gerada uma lista com todos os relatórios, primeiramente um relatório será selecionado
    //na sequência clicar no check-box todos serviços, clicar no botão do campo mês inicial e  clicar no botão do campo mês final, para deixar os campos vazios
    //os relatórios 'Emissão do Cardápio do Mês (Custo)', 'Emissão do Cardápio do Mês (Custo Tipo de Prato)' e 'Emissão do Cardápio do Mês (Período por Página)', o método possuí uma condicional para fazer a verificação da mensagem de campo obrigatório
    //caso o relatório seja 'Emissão do Cardápio do Mês (Custo)' ou 'Emissão do Cardápio do Mês (Custo Tipo de Prato)', irá clicar no botão do campo unidade
    //clicar no botão do campo tipo custo, clicar no botão relatório. Verificar a mensagem de campo obrigatório nos campos: unidade, tipo custo, serviço, mês inicial e final
    //caso o relatório seja 'Emissão do Cardápio do Mês (Período por Página)', irá clicar no botão do campo tipo de custo, clicar no botão relatório. Verificar a mensagem de campo obrigatório nos campos: unidade, tipo custo, serviço, mês inicial e final
    //caso o relatório selecionado seja diferente dos 3 citados anteriormente, irá clicar no botão relatório e verificar a mensagem de campo obrigatório nos campos: unidade, serviço, mês inicial e final
    //após concluir a verificação dos campos de um relatório a tela será atualizada, será selecionado um novo relatório e refeito o processo para a geração da mensagem de campo obrigatório. Respeitando as condições para geração e verificação das mensagens de acordo com o relatório selecionado
    @Test
    public void camposObrigatorios() {
        emissaoCardapioMesPage = new EmissaoCardapioMesPage();
        emissaoCardapioMesFlows = new EmissaoCardapioMesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioMesFlows.navegateTelaEmissaoCardapioMes();
        emissaoCardapioMesPage.camposObrigatorios();
    }


    //acessar a tela 'Emissão do Cardápio do Mês'
    //clicar no campo mês inicial e selecionar NOV, clicar no campo mês final e selecionar OUT
    //clicar no botão relatório e verificar a mensagem exibida na tela informando que o mês inicial deve ser menor ou igual ao mês final
    //clicar em ok
    @Test
    public void mesInicialMaiorQueFinal() {
        emissaoCardapioMesPage = new EmissaoCardapioMesPage();
        emissaoCardapioMesFlows = new EmissaoCardapioMesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioMesFlows.navegateTelaEmissaoCardapioMes();
        emissaoCardapioMesPage.mesInicialMaiorQueFinal();
    }



    //acessar a tela 'Emissão do Cardápio do Mês'
    //com o relatório 'Emissão do Cardápio do Mês' selecionado, verificar se as opções ('todas' unidades, 'todos' serviços, imprimir mensagem, imprimir nome fantasia
    //imprimir dias sem cardápio, imprimir, número e percentual) estão selecionadas ou não
    //clicar em todos os campos e verificar se os que estavam selecionados passaram a não estar mais, e os que não estavam selecionados passaram a estar
    //verificar se com a opção 'imprimir' desmarcada, as opções (número e percentual) das comensais estão desabilitados
    //selecionar a opção 'imprimir', clicar na opção percentual e verificar se a mesma passa a estar selecionada e o número não mais
    //clicar na opção número e verificar se a mesma passa a estar selecionada e a percentual passa não estar mais selecionada
    @Test
    public void marcarDesmarcarCheckBoxsERadioButtons() {
        emissaoCardapioMesPage = new EmissaoCardapioMesPage();
        emissaoCardapioMesFlows = new EmissaoCardapioMesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioMesFlows.navegateTelaEmissaoCardapioMes();
        emissaoCardapioMesPage.marcarDesmarcarCheckBoxsERadioButtons();
    }



}
