package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.HistoricoAjusteCardapioFlows;
import com.javaseleniumtemplate.pages.HistoricoAjusteCardapioPage;
import org.openqa.selenium.By;
import org.testng.annotations.Test;

public class HistoricoAjusteCardapioTests extends TestBase {

    HistoricoAjusteCardapioPage historicoAjusteCardapioPage;
    HistoricoAjusteCardapioFlows historicoAjusteCardapioFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioHistoricoAjusteCardapio() {
        emitiRelatorio("Histórico Ajuste de Cardápio");
    }

    @Test
    public void relatorioAderenciaPercentual() {
        emitiRelatorio("Aderência de Cardápio (Percentual)");
    }

    @Test
    public void relatorioAderenciaTipoPratoPercentual() {
        emitiRelatorio("Aderência de Cardápio por Tipo de Prato (Percentual)");
    }

    @Test
    public void relatorioAlteracaoCardapio() {
        emitiRelatorio("Alterações do Cardápio");
    }

    @Test
    public void relatorioLogAlteracoes() {
        emitiRelatorio("Log de Alterações no Cardápio");
    }

    @Test
    public void relatorioModificacaoComensais() {
        emitiRelatorio("Modificação em Comensais");
    }

    @Test
    public void relatorioModificacaoPratos() {
        emitiRelatorio("Modificação em Pratos");
    }


    //acessar a tela 'Histórico Ajuste de Cardápio'
    //selecionar o relatório que foi passado como parâmetro
    //clicar no check-box 'todas' unidade
    //clicar no campo cardápio de, caso o ano selecionado seja maior que 2023, irá clicar no botão para diminuir o ano até que o mesmo chegue em 2023
    //clicar no mês de novembro
    //gerar o relatório e fechar a guia do mesmo
    //clicar no campo agrupamento de unidades e selecionar o agrupamento PRODUCAO - PRODUTO ACABADO
    //gerar o relatório e fechar a guia do mesmo
    //clicar no check-box 'Todas' do campo unidade, clicar no campo unidade, selecionar as unidades (Deposito Jabaquara e Deposito BC 111), clicar em ok
    //clicar no check-box 'Todos' do campo serviço, clicar no campo serviço, selecionar os serviços (Almoço Especial, Jantar e Distribuição), clicar em ok
    //caso o relatório seja diferente de 'Modificação em Comensais' e 'Modificação em Prato', clicar no check-box 'Todos' do campo tipo de prato, clicar no campo tipo de prato, selecionar os tipos de prato (arroz, principal, feijão e sobremesa), clicar em ok
    //gerar o relatório e fechar a guia do mesmo
    public void emitiRelatorio(String nomeRelatorio) {
        historicoAjusteCardapioPage = new HistoricoAjusteCardapioPage();
        historicoAjusteCardapioFlows = new HistoricoAjusteCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        historicoAjusteCardapioFlows.navegateTelaHistoricoAjusteCardapio();
        historicoAjusteCardapioPage.selecionarRelatorio(nomeRelatorio);
        historicoAjusteCardapioPage.selecionarTodasUnidades();
        historicoAjusteCardapioPage.selecionarNovembro2023();
        historicoAjusteCardapioPage.geraRelatorio();
        historicoAjusteCardapioPage.selecionarAgrupamentoProdutoAcabado();
        historicoAjusteCardapioPage.geraRelatorio();
        historicoAjusteCardapioPage.selecionarUnidades();
        historicoAjusteCardapioPage.selecionarServicos();
        if (!nomeRelatorio.equals("Modificação em Comensais") && !nomeRelatorio.equals("Modificação em Pratos")) historicoAjusteCardapioPage.selecionarTipoPrato();
        historicoAjusteCardapioPage.geraRelatorio();
    }




    //acessar a tela 'Histórico Ajuste de Cardápio'
    //clicar no botão do campo relatório, clicar no check-box 'Todos' do campo serviço, clicar no check-box 'Todos' do campo tipo de prato
    //clicar no botão do campo 'cardápio de', clicar no botão relatório
    //verificar se a mensagem de campo obrigatório é exibida nos campos: relatório, unidade, serviço, tipo de prato e cardápio de
    //preencher o percentual mínimo com o valor 7,9
    //clicar em um componente fora do campo percentual mínimo, neste caso o componente é o 'Todos' do campo unidade
    //verificar se o valor 7,9 continua sendo apresentado no percentual mínimo
    @Test
    public void verificandoComponentes() {
        historicoAjusteCardapioPage = new HistoricoAjusteCardapioPage();
        historicoAjusteCardapioFlows = new HistoricoAjusteCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        historicoAjusteCardapioFlows.navegateTelaHistoricoAjusteCardapio();
        historicoAjusteCardapioPage.campoObrigatorios();
        historicoAjusteCardapioPage.preencherPercentualMinimo();
    }

}
