package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.NutrientesCardapioFlows;
import com.javaseleniumtemplate.pages.NutrientesCardapioPage;
import org.testng.annotations.Test;

public class NutrientesCardapioTests extends TestBase {

    NutrientesCardapioPage nutrientesCardapioPage;
    NutrientesCardapioFlows nutrientesCardapioFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioAnaliticoData() {
        emitiRelatorio("Nutrientes do Cardápio (Analítico por Data)");
    }

    @Test
    public void relatorioAnaliticoServico() {
        emitiRelatorio("Nutrientes do Cardápio (Analítico por Serviço)");
    }

    @Test
    public void relatorioSinteticoData() {
        emitiRelatorio("Nutrientes do Cardápio (Sintético por Data)");
    }

    @Test
    public void relatorioSinteticoServico() {
        emitiRelatorio("Nutrientes do Cardápio (Sintético por Serviço)");
    }

    @Test
    public void relatorioColuna() {
        emitiRelatorio("Nutrientes do Cardápio (Coluna)");
    }

    @Test
    public void relatorioEtiqueta() {
        emitiRelatorio("Nutrientes do Cardápio (Etiqueta)");
    }

    @Test
    public void relatorioPorGrupoNutrientes() {
        emitiRelatorio("Nutrientes do Cardápio ( por Grupo de Nutrientes)");
    }



    //acessar a tela 'Nutrientes do Cardápio'
    //selecionar o relatório que foi passado como parâmetros
    //preencher o intervalo de data
    //clicar no botão relatório, tipo pdf, clicar em confirmar, fechar a guia do relatório
    //selecionar os serviços: solicitação e distribuição
    //caso o nome do relatório seja diferente de Nutrientes do Cardápio (Coluna) e Nutrientes do Cardápio (Etiqueta), serão selecionados os nutrientes. Nestes 2 relatórios não são selecionados, pois os campos estão desabilitados
    //selecionar os tipos de prato: principal e feijão
    //clicar no botão relatório, tipo pdf, clicar em confirmario, fechar a guia do relatório
    public void emitiRelatorio(String nomeRelatorio) {
        nutrientesCardapioPage = new NutrientesCardapioPage();
        nutrientesCardapioFlows = new NutrientesCardapioFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/08/2022";
        String dataFinal = "31/10/2022";

        loginFlows.efetuarLogin();
        nutrientesCardapioFlows.navegateNutrientesCardapio();
        nutrientesCardapioPage.selecionaRelatorio(nomeRelatorio);
        nutrientesCardapioPage.preencherDatas(dataInicial, dataFinal);
        nutrientesCardapioPage.geraRelatorio(nomeRelatorio);
        nutrientesCardapioPage.selecionarServicos();

        if(nomeRelatorio != "Nutrientes do Cardápio (Coluna)" && nomeRelatorio != "Nutrientes do Cardápio (Etiqueta)") {
            nutrientesCardapioPage.selecionarNutrientes();
        }
        nutrientesCardapioPage.selecionarTipoPrato();
        nutrientesCardapioPage.geraRelatorio(nomeRelatorio);
    }



    //acessar a tela 'Nutrientes do Cardápio'
    //selecionar o relatório Nutrientes do Cardápio (Analítico por Data), clicar no botão do campo unidade, botão do campo data, 'todos' serviço, 'todos' nutriente e 'todos' tipo de prato
    //clicar no botão gerar relatório e verificar a mensagem de campo obrigatório nos campos: unidade, data, serviço, nutriente e tipo de prato
    //atualizar a página, selecionar o relatório Nutrientes do Cardápio (Analítico por Serviço), clicar no botão do campo unidade, botão do campo data, 'todos' serviço, 'todos' nutriente e 'todos' tipo de prato
    //clicar no botão gerar relatório e verificar a mensagem de campo obrigatório nos campos: unidade, data, serviço, nutriente e tipo de prato
    //atualizar a página, selecionar o relatório Nutrientes do Cardápio (Sintético por Data), clicar no botão do campo unidade, botão do campo data, 'todos' serviço, 'todos' nutriente e 'todos' tipo de prato
    //clicar no botão gerar relatório e verificar a mensagem de campo obrigatório nos campos: unidade, data, serviço, nutriente e tipo de prato
    //atualizar a página, selecionar o relatório Nutrientes do Cardápio (Sintético por Serviço), clicar no botão do campo unidade, botão do campo data, 'todos' serviço, 'todos' nutriente e 'todos' tipo de prato
    //clicar no botão gerar relatório e verificar a mensagem de campo obrigatório nos campos: unidade, data, serviço, nutriente e tipo de prato
    //atualizar a página, selecionar o relatório Nutrientes do Cardápio (Coluna), clicar no botão unidade, clicar no botão data, 'todos' serviço e 'todos' tipo de prato
    //clicar no botão gerar relatório e verificar a mensagem de campo obrigatório nos campos: unidade, data, serviço e tipo de prato
    //atualizar a página, selecionar o relatório Nutrientes do Cardápio (Etiqueta), clicar no botão unidade, clicar no botão data, 'todos' serviço e 'todos' tipo de prato
    //clicar no botão gerar relatório e verificar a mensagem de campo obrigatório nos campos: unidade, data, serviço e tipo de prato
    //selecionar o relatório Nutrientes do Cardápio ( por Grupo de Nutrientes), clicar no botão do campo unidade, botão do campo data, 'todos' serviço, 'todos' nutriente e 'todos' tipo de prato
    //clicar no botão gerar relatório e verificar a mensagem de campo obrigatório nos campos: unidade, data, serviço, nutriente e tipo de prato
    @Test
    public void camposObrigatorios() {
        nutrientesCardapioPage = new NutrientesCardapioPage();
        nutrientesCardapioFlows = new NutrientesCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesCardapioFlows.navegateNutrientesCardapio();
        nutrientesCardapioPage.selecionaRelatorio("Nutrientes do Cardápio (Analítico por Data)");
        nutrientesCardapioPage.verificarCamposObrigatorios("Nutrientes do Cardápio (Analítico por Data)");

        nutrientesCardapioPage.refresh();
        nutrientesCardapioPage.selecionaRelatorio("Nutrientes do Cardápio (Analítico por Serviço)");
        nutrientesCardapioPage.verificarCamposObrigatorios("Nutrientes do Cardápio (Analítico por Serviço)");

        nutrientesCardapioPage.refresh();
        nutrientesCardapioPage.selecionaRelatorio("Nutrientes do Cardápio (Sintético por Data)");
        nutrientesCardapioPage.verificarCamposObrigatorios("Nutrientes do Cardápio (Sintético por Data)");

        nutrientesCardapioPage.refresh();
        nutrientesCardapioPage.selecionaRelatorio("Nutrientes do Cardápio (Sintético por Serviço)");
        nutrientesCardapioPage.verificarCamposObrigatorios("Nutrientes do Cardápio (Sintético por Serviço)");

        nutrientesCardapioPage.refresh();
        nutrientesCardapioPage.selecionaRelatorio("Nutrientes do Cardápio (Coluna)");
        nutrientesCardapioPage.verificarCamposObrigatorios("Nutrientes do Cardápio (Coluna)");

        nutrientesCardapioPage.refresh();
        nutrientesCardapioPage.selecionaRelatorio("Nutrientes do Cardápio (Etiqueta)");
        nutrientesCardapioPage.verificarCamposObrigatorios("Nutrientes do Cardápio (Etiqueta)");

        nutrientesCardapioPage.refresh();
        nutrientesCardapioPage.selecionaRelatorio("Nutrientes do Cardápio ( por Grupo de Nutrientes)");
        nutrientesCardapioPage.verificarCamposObrigatorios("Nutrientes do Cardápio ( por Grupo de Nutrientes)");
    }


    //acessar a tela 'Nutrientes do Cardápio'
    //selecionar o relatório Nutrientes do Cardápio (Analítico por Data), verificar se os campos: imprimir opções, imprimir NDPCal, serviço, nutriente e tipo de prato, estão habilitados
    //selecionar o relatório Nutrientes do Cardápio (Analítico por Serviço), verificar se os campos: imprimir opções, imprimir NDPCal, serviço, nutriente e tipo de prato, estão habilitados
    //selecionar o relatório Nutrientes do Cardápio (Sintético por Data), verificar se os campos: imprimir opções, imprimir NDPCal, serviço, nutriente e tipo de prato, estão habilitados
    //selecionar o relatório Nutrientes do Cardápio (Sintético por Serviço), verificar se os campos: imprimir opções, imprimir NDPCal, serviço, nutriente e tipo de prato, estão habilitados
    //selecionar o relatório Nutrientes do Cardápio (Coluna), verificar se os campos: serviço e tipo de prato, estão habilitados. Verificar se os campos imprimir opções, imprimir NDPCal e nutrientes, estão desabilitados
    //selecionar o relatório Nutrientes do Cardápio (Etiqueta), verificar se os campos: serviço e tipo de prato, estão habilitados. Verificar se os campos imprimir opções, imprimir NDPCal e nutrientes, estão desabilitados
    //selecionar o relatório Nutrientes do Cardápio ( por Grupo de Nutrientes), verificar se os campos: serviço, nutriente, tipo de prato e imprimir opções estão habilitados. Verificar se o campo imprimir NDPCal está desabilitado
    @Test
    public void camposHabilitadosPelosRelatorios() {
        nutrientesCardapioPage = new NutrientesCardapioPage();
        nutrientesCardapioFlows = new NutrientesCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesCardapioFlows.navegateNutrientesCardapio();
        nutrientesCardapioPage.verificarOpcoesHabilitadasPelosRelatorios();
    }


}