package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PesoProdutoUnidadeFlows;
import com.javaseleniumtemplate.pages.PesoProdutoUnidadePage;
import org.testng.annotations.Test;

public class PesoProdutoUnidadeTests extends TestBase {

    PesoProdutoUnidadePage pesoProdutoUnidadePage;
    PesoProdutoUnidadeFlows pesoProdutoUnidadeFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Peso do Produto na Unidade'
    //no filtro inicial selecionar a unidade Deposito Jabaquara, clicar no botão aplicar filtro
    //verificar se no topo da página é apresentada a unidade que foi selecionada no filtro
    //no filtro da tela de produtos, procurar pelo código 101110200601 e verificar o código e nome do produto encontrado são os do produto esperado
    //clicar no campo peso, inserir o valor 5, clicar no botão salvar alterações, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se o peso do produto foi salvo corretamente
    //no filtro da tela de produtos, procurar pelo código 101110200601
    //clicar no campo do peso, deixar o campo vazio, clicar no botão salvar alterações, verificar se o peso foi salvo com o campo vazio
    @Test
    public void adicionarRemoverPeso() {
        pesoProdutoUnidadePage = new PesoProdutoUnidadePage();
        pesoProdutoUnidadeFlows = new PesoProdutoUnidadeFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pesoProdutoUnidadeFlows.navegatePesoProdutoUnidade();
        pesoProdutoUnidadePage.selecionarUnidadeDepositoJabaquara();
        pesoProdutoUnidadePage.inserirPesoProduto();
        pesoProdutoUnidadePage.removerPesoProduto();
    }


    //acessar a tela 'Peso do Produto na Unidade'
    //no filtro inicial selecionar a unidade Deposito Jabaquara, clicar no botão aplicar filtro
    //verificar se no topo da página é apresentada a unidade que foi selecionada no filtro
    //no filtro da tela de produtos, procurar pelo código 101110201502 e verificar o código e nome do produto encontrado são os do produto esperado
    //clicar no campo peso, alterar o valor para 5,9 clicar no botão salvar alterações, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //atualizar a página, selecionar a unidade Deposito Jabaquara, procurar pelo produto de código 101110201502 e verificar se o peso de 5,9 foi salvo corretamente
    //clicar no campo peso, alterar o valor para 7, retornando para o valor que estava no início do teste, clicar no botão salvar alterações
    //verificar se o peso foi salvo corretamente
    @Test
    public void editarPesoProduto() {
        pesoProdutoUnidadePage = new PesoProdutoUnidadePage();
        pesoProdutoUnidadeFlows = new PesoProdutoUnidadeFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pesoProdutoUnidadeFlows.navegatePesoProdutoUnidade();
        pesoProdutoUnidadePage.selecionarUnidadeDepositoJabaquara();
        pesoProdutoUnidadePage.editarPesoProduto();
    }


    //acessar a tela 'Peso do Produto na Unidade'
    //selecionar a unidade Deposito Jabaquara, clicar no botão do campo unidade, clicar no botão aplicar filtro
    //verificar a mensagem de campo obrigatório no campo unidade
    @Test
    public void campoObrigatorioUnidade() {
        pesoProdutoUnidadePage = new PesoProdutoUnidadePage();
        pesoProdutoUnidadeFlows = new PesoProdutoUnidadeFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pesoProdutoUnidadeFlows.navegatePesoProdutoUnidade();
        pesoProdutoUnidadePage.campoObrigatorioUnidade();
    }


}
