package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PratoFlows;
import com.javaseleniumtemplate.pages.PratoPage;
import org.testng.annotations.Test;

public class PratoTests extends TestBase {

    PratoPage pratoPage;
    PratoFlows pratoFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita padrão
    //clicar na aba dados da receita, clicar em editar, selecionar o produto de produto BARATA ORIENTAL
    //verificar a mensagem exibida na tela informando que o produto de produto já está sendo usado, clicar em ok e clicar em cancelar
    @Test
    public void produtoProducaoSendoUsadoReceitaPadrao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrão";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.produtoProducaoRepetido(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita padrão
    //clicar em adicionar, deixar o campo Ap. Cocção(%) vazio, verificar a mensagem exibida na tela informando que deve ser maior que 0, clicar em ok
    //deixar o campo Ap. Limpeza(%) vazio e verificar a mensagem exibida na tela informando que deve ser entre 1% e 100%
    //clicar em ok, clicar em cancelar
    @Test
    public void aproveitamentoCoccaoLimpezaVaziosPadrao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrão";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.aproveitamentoCoccaoELimpezaVazios(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita padrão
    //clicar em adicionar, selecionar o produto CARUM CARVI (FRUTO), selecionar qt fixa sim, preencher a quant. bruta, ganho cocção, perda limpeza, degelo, req para, complemento, compl. entrega direta, tem, pr base, dia sem lim seg, e ap limpeza
    //clicar em salvar, verificar se o produto foi adicionado com todas as informações corretas
    //clicar no produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void adicionarProdutoReceitaPadrao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrão";
        String produto = "CARUM CARVI (FRUTO)";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarCarumPadrao();
        pratoPage.verificarCarumPadrao();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita padrão
    //clicar em adicionar, selecionar o produto NITRATO DE PRATA, preencher a quantidade, clicar em salvar e verificar a mensagem de sucesso exibida no canto da tela
    //acessar o produto, alterar a quantidade, clicar em salvar, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //clicar na aba dados da receita, clicar no botão calcular, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela, verificar se a quantidade/pessoa calculada corretamente, clicar na aba produtos da receita
    //clicar na aba dados da receita, clicar em editar, alterar as informações: nome fantasia, status, quantidade/pessoa, data de inativação, medida caseira, quantidade, descrição, quantidade container, mínimo container e amostra
    //clicar em salvar, verificar a mensagem exibida na tela informando que a data de inativação deve ser maior que a data atual, clicar em ok, inserir uma data maior, clicar em salvar
    //verificar a mensagem exibida na tela sobre alteração proporcional dos produtos, clicar em sim
    //verificar se as informações alteradas foram salvas corretamente
    //desfazer todas as alterações realizadas, clicar na aba produtos da receita
    //clicar no produto NITRATO DE PRATA, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void editarDadosReceitaCalcularQuantidadePessoaReceitaPadrao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrão";
        String produto = "NITRATO DE PRATA";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarNitratoDePrata(receita);
        pratoPage.editarProdutoNitratoDePrata(receita);
        pratoPage.calcularQuantPessoa(receita);
        pratoPage.editarDadosReceitaPadrao();
        pratoPage.verificarEdicaoDadosReceitaPadrao();
        pratoPage.desfazerEdicaoDadosReceitaPadrao();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba modo de preparo, clicar na receita padrão
    //clicar em adicionar, selecionar o status ativo, preencher os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente
    //clicar no modo de preparo, clicar em editar, alterar o status para inativo, alterar os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente após as alterações
    //clicar no modo de preparo, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela e verificar a mensagem de não há registro exibida no grid da lista de modos de preparo
    @Test
    public void modoPreparoReceitaPadrao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrão";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecModoPreparo(receita);
        pratoPage.adicionarModoPreparoPadrao();
        pratoPage.editarModoPreparoPadrao();
        pratoPage.excluirModoPreparo(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita padrão
    //clicar no botão adicionar, adicionar o produto CARUM CARVI (FRUTO), clicar no botão ações
    //clicar em 'Consultar Nutrientes', verificar se colunas (código, nome, un, quantidade) são apresentadas no grid, clicar em voltar
    //clicar no produto CARUM CARVI (FRUTO), clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void consultarNutrientesReceitaPadrao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrão";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.consultarNutrientesReceita();
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita local
    //clicar na aba dados da receita, clicar em editar, selecionar o produto de produto BARATA ORIENTAL
    //verificar a mensagem exibida na tela informando que o produto de produto já está sendo usado, clicar em ok e clicar em cancelar
    @Test
    public void produtoProducaoSendoUsadoReceitaLocal() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Local";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.produtoProducaoRepetido(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita local
    //clicar em adicionar, deixar o campo Ap. Cocção(%) vazio, verificar a mensagem exibida na tela informando que deve ser maior que 0, clicar em ok
    //deixar o campo Ap. Limpeza(%) vazio e verificar a mensagem exibida na tela informando que deve ser entre 1% e 100%
    //clicar em ok, clicar em cancelar
    @Test
    public void aproveitamentoCoccaoLimpezaVaziosLocal() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Local";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.aproveitamentoCoccaoELimpezaVazios(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita local
    //clicar em adicionar, selecionar o produto CARUM CARVI (FRUTO), selecionar qt fixa sim, preencher a quant. bruta, ganho cocção, perda limpeza, degelo, req para, complemento, compl. entrega direta, tem, pr base, dia sem lim seg, e ap limpeza
    //clicar em salvar, verificar se o produto foi adicionado com todas as informações corretas
    //clicar no produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void adicionarProdutoReceitaLocal() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Local";
        String produto = "CARUM CARVI (FRUTO)";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarCarumLocal();
        pratoPage.verificarCarumLocal();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita local
    //clicar em adicionar, selecionar o produto NITRATO DE PRATA, preencher a quantidade, clicar em salvar e verificar a mensagem de sucesso exibida no canto da tela
    //acessar o produto, alterar a quantidade, clicar em salvar, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //clicar na aba dados da receita, clicar no botão calcular, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela, verificar se a quantidade/pessoa calculada corretamente, clicar na aba produtos da receita
    //clicar na aba dados da receita, clicar em editar, alterar as informações: nome fantasia, status, quantidade/pessoa, data de inativação, medida caseira, quantidade, descrição, quantidade container, mínimo container e amostra
    //clicar em salvar, verificar a mensagem exibida na tela informando que a data de inativação deve ser maior que a data atual, clicar em ok, inserir uma data maior, clicar em salvar
    //verificar a mensagem exibida na tela sobre alteração proporcional dos produtos, clicar em sim
    //verificar se as informações alteradas foram salvas corretamente
    //desfazer todas as alterações realizadas, clicar na aba produtos da receita
    //clicar no produto NITRATO DE PRATA, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void editarDadosReceitaCalcularQuantidadePessoaReceitaLocal() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Local";
        String produto = "NITRATO DE PRATA";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarNitratoDePrata(receita);
        pratoPage.editarProdutoNitratoDePrata(receita);
        pratoPage.calcularQuantPessoa(receita);
        pratoPage.editarDadosReceitaLocal();
        pratoPage.verificarEdicaoDadosReceitaLocal();
        pratoPage.desfazerEdicaoDadosReceitaLocal();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba modo de preparo, clicar na receita local
    //clicar em adicionar, selecionar o status ativo, preencher os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente
    //clicar no modo de preparo, clicar em editar, alterar o status para inativo, alterar os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente após as alterações
    //clicar no modo de preparo, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela e verificar a mensagem de não há registro exibida no grid da lista de modos de preparo
    @Test
    public void modoPreparoReceitaLocal() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Local";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecModoPreparo(receita);
        pratoPage.adicionarModoPreparoLocal();
        pratoPage.editarModoPreparoPadrao();
        pratoPage.editarModoPreparoLocal();
        pratoPage.excluirModoPreparo(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba receita, clicar em receita local
    //clicar no botão adicionar, adicionar o produto CARUM CARVI (FRUTO), clicar no botão ações
    //clicar em 'Consultar Nutrientes', verificar se colunas (código, nome, un, quantidade) são apresentadas no grid, clicar em voltar
    //clicar no produto CARUM CARVI (FRUTO), clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void consultarNutrientesReceitaLocal() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Local";
        String produto = "CARUM CARVI (FRUTO)";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarCarumLocal();
        pratoPage.consultarNutrientesReceita();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, clicar na receita por serviço, clicar no campo serviço e selecionar o serviço Janta
    //clicar na aba dados da receita, clicar em editar, selecionar o produto de produto BARATA ORIENTAL
    //verificar a mensagem exibida na tela informando que o produto de produto já está sendo usado, clicar em ok e clicar em cancelar
    @Test
    public void produtoProducaoSendoUsadoReceitaServico() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Serviço";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.produtoProducaoRepetido(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, clicar na receita por serviço, clicar no campo serviço e selecionar o serviço Janta
    //clicar em adicionar, deixar o campo Ap. Cocção(%) vazio, verificar a mensagem exibida na tela informando que deve ser maior que 0, clicar em ok
    //deixar o campo Ap. Limpeza(%) vazio e verificar a mensagem exibida na tela informando que deve ser entre 1% e 100%
    //clicar em ok, clicar em cancelar
    @Test
    public void aproveitamentoCoccaoLimpezaVaziosServico() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Serviço";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.aproveitamentoCoccaoELimpezaVazios(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, clicar na receita por serviço, clicar no campo serviço e selecionar o serviço Janta
    //clicar em adicionar, selecionar o produto CARUM CARVI (FRUTO), selecionar qt fixa sim, preencher a quant. bruta, ganho cocção, perda limpeza, degelo,req para, complemento, compl. entrega direta, tem, pr base, dia sem lim seg, e ap limpeza
    //clicar em salvar, verificar se o produto foi adicionado com todas as informações corretas
    //clicar no produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void adicionarProdutoReceitaServico() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Serviço";
        String produto = "CARUM CARVI (FRUTO)";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarCarumServico();
        pratoPage.verificarCarumServico();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, clicar na receita por serviço, clicar no campo serviço e selecionar o serviço Janta
    //clicar em adicionar, selecionar o produto NITRATO DE PRATA, preencher a quantidade, clicar em salvar e verificar a mensagem de sucesso exibida no canto da tela
    //acessar o produto, alterar a quantidade, clicar em salvar, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //clicar na aba dados da receita, clicar no botão calcular, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela, verificar se a quantidade/pessoa calculada corretamente, clicar na aba produtos da receita
    //clicar na aba dados da receita, clicar em editar, alterar as informações: nome fantasia, status, quantidade/pessoa, data de inativação, medida caseira, quantidade, descrição, quantidade container, mínimo container e amostra
    //clicar em salvar, verificar a mensagem exibida na tela informando que a data de inativação deve ser maior que a data atual, clicar em ok, inserir uma data maior, clicar em salvar
    //verificar a mensagem exibida na tela sobre alteração proporcional dos produtos, clicar em sim
    //verificar se as informações alteradas foram salvas corretamente
    //desfazer todas as alterações realizadas, clicar na aba produtos da receita
    //clicar no produto NITRATO DE PRATA, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void editarDadosReceitaCalcularQuantidadePessoaReceitaServico() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Serviço";
        String produto = "NITRATO DE PRATA";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarNitratoDePrata(receita);
        pratoPage.editarProdutoNitratoDePrata(receita);
        pratoPage.calcularQuantPessoa(receita);
        pratoPage.editarDadosReceitaServico();
        pratoPage.verificarEdicaoDadosReceitaServico();
        pratoPage.desfazerEdicaoDadosReceitaServico();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba modo de preparo, clicar na receita serviço, selecionar o serviço janta
    //clicar em adicionar, selecionar o status ativo, preencher os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente
    //clicar no modo de preparo, clicar em editar, alterar o status para inativo, alterar os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente após as alterações
    //clicar no modo de preparo, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela e verificar a mensagem de não há registro exibida no grid da lista de modos de preparo
    @Test
    public void modoPreparoReceitaServico() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Serviço";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecModoPreparo(receita);
        pratoPage.adicionarModoPreparoServico();
        pratoPage.editarModoPreparoServico();
        pratoPage.excluirModoPreparo(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, clicar na receita por serviço, clicar no campo serviço e selecionar o serviço Janta
    //clicar no botão adicionar, adicionar o produto CARUM CARVI (FRUTO), clicar no botão ações
    //clicar em 'Consultar Nutrientes', verificar se colunas (código, nome, un, quantidade) são apresentadas no grid, clicar em voltar
    //clicar no produto CARUM CARVI (FRUTO), clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void consultarNutrientesReceitaServico() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Serviço";
        String produto = "CARUM CARVI (FRUTO)";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarCarumServico();
        pratoPage.consultarNutrientesReceita();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, selecionar a receita padrão de qualidade, clicar no campo padrão de qualidade e selecionar o padrão excelente
    //clicar em adicionar, clicar no botão do campo produto, pesquisar pelo produto CARUM CARVI (FRUTO) e selecionar o mesmo
    //selecionar a opção 'sim' nos campos Qt Fixa e Pr Base, preencher a quantidade bruta, clicar em salvar
    //verificar se as informações do produto foram salvas corretamente
    //clicar no produto CARUM CARVI (FRUTO), clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void adicionarProdutoReceitaPadraoQualidade() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrão de Qualidade";
        String produto = "CARUM CARVI (FRUTO)";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarCarumPadraoQualidade();
        pratoPage.verificarCarumPadraoQualidade();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, selecionar a receita padrão de qualidade, clicar no campo padrão de qualidade e selecionar o padrão excelente
    //clicar em adicionar, deixar o campo Ap. Cocção(%) vazio, verificar a mensagem exibida na tela informando que deve ser maior que 0, clicar em ok
    //deixar o campo Ap. Limpeza(%) vazio e verificar a mensagem exibida na tela informando que deve ser entre 1% e 100%
    //clicar em ok, clicar em cancelar
    @Test
    public void aproveitamentoCoccaoLimpezaVaziosPadraoQualidade() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrão de Qualidade";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.aproveitamentoCoccaoELimpezaVazios(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, selecionar a receita padrão de qualidade, clicar no campo padrão de qualidade e selecionar o padrão excelente
    //clicar em adicionar, selecionar o produto NITRATO DE PRATA, preencher a quantidade, clicar em salvar e verificar a mensagem de sucesso exibida no canto da tela
    //acessar o produto, alterar a quantidade, clicar em salvar, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //clicar na aba dados da receita, clicar no botão calcular, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela, verificar se a quantidade/pessoa calculada corretamente, clicar na aba produtos da receita
    //clicar na aba dados da receita, clicar em editar, alterar a data de inativação para 05/07/2022, clicar em salvar, verificar a mensagem exibida na tela informando que a data de inativação deve ser maior que a data atual, clicar em ok
    //alterar a data de inativação para 05/07/2031, clicar em salvar, verificar a mensagem exibida na tela sobre alterar a quantidade proporcionalmente dos produto, clicar em sim
    //clicar em editar, verificar se a data de inativação foi salva corretamente, clicar em cancelar
    //clicar em editar, desfazer as edição, deixando a data de inativação vazia, clicar em salvar, clicar em sim
    //clicar no produto NITRATO DE PRATA, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void editarDadosReceitaCalcularQuantidadePessoaReceitaPadraoQualidade() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrão de Qualidade";
        String produto = "NITRATO DE PRATA";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarNitratoDePrata(receita);
        pratoPage.editarProdutoNitratoDePrata(receita);
        pratoPage.calcularQuantPessoaPadraoQualidade();
        pratoPage.editarDadosReceitaPadraoQualidade();
        pratoPage.verificarEdicaoDadosReceitaPadraoQualidade();
        pratoPage.desfazerEdicaoDadosReceitaPadraoQualidade();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba modo de preparo, clicar na receita padrão de qualidade, selecionar o padrão excelente
    //clicar em adicionar, selecionar o status ativo, preencher os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente
    //clicar no modo de preparo, clicar em editar, alterar o status para inativo, alterar os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente após as alterações
    //clicar no modo de preparo, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela e verificar a mensagem de não há registro exibida no grid da lista de modos de preparo
    @Test
    public void modoPreparoReceitaPadraoQualidade() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Padrao de Qualidade";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecModoPreparo(receita);
        pratoPage.adicionarModoPreparoPadraoQualidade();
        pratoPage.editarModoPreparoPadraoQualidade();
        pratoPage.excluirModoPreparo(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, selecionar a receita por região, selecionar o padrão de qualidade excelente e a região Belo Horizonte
    //clicar em adicionar, clicar no botão do campo produto, pesquisar pelo produto CARUM CARVI (FRUTO) e selecionar o mesmo
    //selecionar a opção 'sim' nos campos Qt Fixa e Pr Base, preencher a quantidade bruta, clicar em salvar
    //verificar se as informações do produto foram salvas corretamente
    //clicar no produto CARUM CARVI (FRUTO), clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void adicionarProdutoReceitaRegiao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Região";
        String produto = "CARUM CARVI (FRUTO)";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarCarumRegiao();
        pratoPage.verificarCarumRegiao();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, selecionar a receita por região, selecionar o padrão de qualidade excelente e a região Belo Horizonte
    //clicar em adicionar, deixar o campo Ap. Cocção(%) vazio, verificar a mensagem exibida na tela informando que deve ser maior que 0, clicar em ok
    //deixar o campo Ap. Limpeza(%) vazio e verificar a mensagem exibida na tela informando que deve ser entre 1% e 100%
    //clicar em ok, clicar em cancelar
    @Test
    public void aproveitamentoCoccaoLimpezaVaziosRegiao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Região";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.aproveitamentoCoccaoELimpezaVazios(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba receita, selecionar a receita por região, selecionar o padrão de qualidade excelente e a região Belo Horizonte
    //clicar em adicionar, selecionar o produto NITRATO DE PRATA, preencher a quantidade, clicar em salvar e verificar a mensagem de sucesso exibida no canto da tela
    //acessar o produto, alterar a quantidade, clicar em salvar, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //clicar na aba dados da receita, clicar no botão calcular, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem exibida na tela sobre alteração proporcional, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela, verificar se a quantidade/pessoa calculada corretamente, clicar na aba produtos da receita
    //clicar na aba dados da receita, clicar em editar, alterar a data de inativação para 05/07/2022, clicar em salvar, verificar a mensagem exibida na tela informando que a data de inativação deve ser maior que a data atual, clicar em ok
    //alterar a data de inativação para 05/07/2031, clicar em salvar, verificar a mensagem exibida na tela sobre alterar a quantidade proporcionalmente dos produto, clicar em sim
    //clicar em editar, verificar se a data de inativação foi salva corretamente, clicar em cancelar
    //clicar em editar, desfazer as edição, deixando a data de inativação vazia, clicar em salvar, clicar em sim
    //clicar no produto NITRATO DE PRATA, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void editarDadosReceitaCalcularQuantidadePessoaReceitaRegiao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Região";
        String produto = "NITRATO DE PRATA";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita(receita);
        pratoPage.adicionarNitratoDePrata(receita);
        pratoPage.editarProdutoNitratoDePrata(receita);
        pratoPage.calcularQuantPessoaPadraoRegiao();
        pratoPage.editarDadosReceitaRegiao();
        pratoPage.verificarEdicaoDadosReceitaRegiao();
        pratoPage.desfazerEdicaoDadosReceitaRegiao();
        pratoPage.excluirProdutoDaReceita(produto);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo, clicar na aba modo de preparo, clicar na receita região, selecionar o padrão excelente e selecionar a região Belo Horizonte
    //clicar em adicionar, selecionar o status ativo, preencher os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente
    //clicar no modo de preparo, clicar em editar, alterar o status para inativo, alterar os campos responsável e texto, clicar em salvar
    //verificar se as informações (status, responsável e texto) foram salvas corretamente após as alterações
    //clicar no modo de preparo, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de sucesso exibida no canto da tela e verificar a mensagem de não há registro exibida no grid da lista de modos de preparo
    @Test
    public void modoPreparoReceitaRegiao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        String receita = "Região";

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecModoPreparo(receita);
        pratoPage.adicionarModoPreparoRegiao();
        pratoPage.editarModoPreparoRegiao();
        pratoPage.excluirModoPreparo(receita);
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba embalagem, clicar no campo opção e selecionar 'principal', clicar no campo container e selecionar o alumínio e clicar em salvar
    //verificar se as informações (opção, container e quantidade) foram salvas corretamente
    //selecionar a embalagem, clicar em editar, alterar a opção para secundária, alterar o container para isopor, alterar a quantidade e clicar em salvar, verificar se os valores alterados foram salvos corretamente
    //selecionar a embalagem, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem de não há registro, exibida no grid da lista de embalagens
    @Test
    public void embalagemPrato() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.adicionarEmbalagem();
        pratoPage.editarEmbalagem();
        pratoPage.excluirEmbalagem();
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clica na aba receita, selecionar a receita padrão, clicar na aba dados da receita, clicar em editar, alterar a finalização para 'unidade' clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela, verificar se a finalização foi salvar corretamente com o valor 'unidade'
    //clicar em editar, alterar a finalização para 'matriz' clicar em salvar e verificar a mensagem de salvo com sucesso exibida no canto da tela, e verificar se o valor foi salvo com matriz
    //acessar a receita local, clicar na aba dados da receita e realizar as mesmas alterações feita na receita padrão. Alterar a finalização para 'unidade', salvar e verificar o valor, alterar para 'matriz' salvar e verificar o valor
    //acessar a receita serviço, clicar na aba dados da receita e realizar as mesmas alterações feita na receita padrão. Alterar a finalização para 'unidade', salvar e verificar o valor, alterar para 'matriz' salvar e verificar o valor
    @Test
    public void alterarFinalizacao() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.selecReceita("Padrão");
        pratoPage.alterarFinalizacao("Padrão");
        pratoPage.selecReceita("Local");
        pratoPage.alterarFinalizacao("Local");
        pratoPage.selecReceita("Serviço");
        pratoPage.alterarFinalizacao("Serviço");
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato SALADA DE ALFACE e acessar o mesmo
    //clicar na aba receita, selecionar a receita padrão, clicar em adicionar, verificar a mensagem exibida na tela informando que o produto de produto existe em outra receita, clicar em ok
    //selecionar o produto querosene, clicar em excluir, e verificar a mensagem exibida na tela informando que o produto de produção existe em outra receita, clicar em ok, clicar em voltar
    //selecionar a receita local e realizar os mesmos testes da receita padrão, tentar adicionar um produto e verificar a mensagem exibida na tela, tentar excluir um produto e verificar a mesma mensagem
    //selecionar a receita serviço e realizar os mesmos testes da receita padrão, tentar adicionar um produto e verificar a mensagem exibida na tela, tentar excluir um produto e verificar a mesma mensagem
    @Test
    public void tentaAlterarRecComProdPadrRepetido() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarSaladaDeAlface();
        pratoPage.selecReceita("Padrão");
        pratoPage.tentarAlterarRecComProdPadrRepetido();
        pratoPage.selecReceita("Local");
        pratoPage.tentarAlterarRecComProdPadrRepetido();
        pratoPage.selecReceita("Serviço");
        pratoPage.tentarAlterarRecComProdPadrRepetido();
    }


    //acessar a tela 'Prato'
    //pesquisar pelo prato FEIJOADA MAGRA e acessar o mesmo
    //clicar na aba embalagens, clicar em adicionar, clicar em salvar e verificar a mensagem de campo obrigatório nos campos: container e quantidade, clicar em cancelar
    //clicar na aba receita, clicar em receita padrão, clicar em adicionar, clicar em salvar e verificar a mensagem de campo obrigatório nos campos: produto, un, quantidade e qt bruta, clicar em cancelar
    //clicar na aba receita, clicar em receita local, clicar em adicionar, clicar em salvar e verificar a mensagem de campo obrigatório nos campos: produto, un, quantidade e qt bruta, clicar em cancelar
    //clicar na aba receita, clicar em receita serviço, selecionar o serviço janta, clicar em adicionar, clicar em salvar e verificar a mensagem de campo obrigatório nos campos: produto, un, quantidade e qt bruta, clicar em cancelar
    //clicar na aba receita, clicar em receita padrão de qualidade, selecionar o padrão excelente, clicar em adicionar, clicar em salvar e verificar a mensagem de campo obrigatório nos campos: produto, un, quantidade e qt bruta, clicar em cancelar
    //clicar na aba receita, clicar em receita região, selecionar o padrão excelente, clicar em adicionar, clicar em salvar e verificar a mensagem de campo obrigatório nos campos: produto, un, quantidade e qt bruta, clicar em cancelar
    @Test
    public void camposObrigatorios() {
        pratoPage = new PratoPage();
        pratoFlows = new PratoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoFlows.navegateTelaPrato();
        pratoPage.acessarFeijoadaMagra();
        pratoPage.camposObrigatoriosAddEmbalagem();
        pratoPage.selecReceita("Padrão");
        pratoPage.camposObrigatoriosAddProdutoReceitaPadrao();
        pratoPage.selecReceita("Local");
        pratoPage.camposObrigatoriosAddProdutoReceitaLocal();
        pratoPage.selecReceita("Serviço");
        pratoPage.camposObrigatoriosAddProdutoReceitaServico();
        pratoPage.selecReceita("Padrão de Qualidade");
        pratoPage.camposObrigatoriosAddProdutoReceitaPadQualidade();
        pratoPage.selecReceita("Região");
        pratoPage.camposObrigatoriosAddProdutoReceitaRegiao();

    }



}
