package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;

import com.javaseleniumtemplate.flows.RequisicaoPorServicoFlows;
import com.javaseleniumtemplate.pages.RequisicaoPorServicoPage;
import org.testng.annotations.Test;

public class RequisicaoPorServicoTests extends TestBase {

    RequisicaoPorServicoPage requisicaoPorServicoPage;
    RequisicaoPorServicoFlows requisicaoPorServicoFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito Jabaquara e o serviço Almoço Especial
    //e selecionar os produtos 'Matéria Prima', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar no botão adicionar, clicar no campo tipo de prato e selecionar o tipo arroz, clicar no campo prato e selecionar o prato arroz temperado
    //clicar no campo produto e selecionar o produto OLEO DE AMENDOAS DOCES, preencher o campo quantidade extra, preencher o campo quantidade devolvida
    //preencher o campo hora limite, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(tipo de prato, nome tipo de prato, prato, nome do prato) foram salvas corretamente
    //clicar no nome do tipo de prato e verificar se as informações(código, produto, unidade, qtde. prevista, qtde. extra, qtde. devolvida, qtde. liberada, data limite, hora limite) do produto foram salvas corretamente
    //clicar no botão adicionar, clicar no campo produto e selecionar CANFORA, preencher a quantidade extra e quantidade devolvida, selecionar a hora limite, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(código, produto, unidade, qtde. prevista, qtde. extra, qtde. devolvida, qtde. liberada) do segundo produto foram salvas corretamente
    //clicar no check-box do segundo produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto da tela, verificar se a requisição possuí apenas 1 produto
    //alterar os valores da quantidade extra e quantidade devolvida do produto, clicar em salvar alterações, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se após as alterações os valores dos campos (qtde. extra, qtde. devolvida) foram salvos corretamente, e o cálculo da qtde. liberada foi realizado corretamente
    //clicar no check-box do produto, clicar no botão excluir, verificar a mensagem exibida na tela informando que o lançamento deve conter no mínimo 1 produto
    //clicar no botão ok, clicar no botão voltar, clicar no check-box do tipo de prato, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de deletado com sucesso exibida no canto da tela, verificar no grid da lista de tipos de pratos a mensagem de não há registro
    @Test
    public void tipoPratoMateriaPrima() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Tipo de Prato";
        String produtos = "Matéria Prima";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, produtos);
        requisicaoPorServicoPage.addRequisicaoTipoPrato();
        requisicaoPorServicoPage.verificarReqTipoPratoAdd();
        requisicaoPorServicoPage.addSegundaProdutoReqTipoPrato();
        requisicaoPorServicoPage.verificarSegundaProdutoAddTipoPrato();
        requisicaoPorServicoPage.excluirSegundoProdReqTipoPrato();
        requisicaoPorServicoPage.alterarQuantProdReqTipoPrato();
        requisicaoPorServicoPage.tentarExcluirUnicoProdReqTipoPrato();
        requisicaoPorServicoPage.excluirReTipoPrato();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito BC 111 e o serviço Almoço
    //e selecionar os produtos 'Matéria Prima', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar no botão adicionar, clicar no campo produto e selecionar o produto CREOSOTO, preencher os campos quantidade extra e quantidade devolvida, preencher o campo hora limite, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(código, produto, unidade, qtde. prevista, qtde.extra, qtde. devolvida, qtde. liberada) do produto foram salvas corretamente
    //clicar no botão adicionar para adicionar um segundo produto, clicar no campo produto e selecionar o produto QUEROSENE, preencher a quantidade extra e quantidade devolvida, preencher o campo hora limite e clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(código, produto, unidade, qtde. prevista, qtde.extra, qtde. devolvida, qtde. liberada) do segundo produto adicionado foram salvas corretamente
    //clicar no check-box do segundo produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem excluída com sucesso exibida no canto da tela, verificar se a requisição passa a ter apenas 1 produto
    //alterar o valores da quantidade extra e quantidade devolvida, clicar no botão salvar alterações, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações dos campos(qtde. extra, qtde. devolvida) foram salvas corretamente e se o cálculo da quantidade liberada foi realizado corretamente
    //clicar no check-box do produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem excluído com sucesso exibida no canto da tela, verificar se no grid da lista de produtos da requisição é apresenta a mensagem não há registros
    @Test
    public void produtoMateriaPrima() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Produto";
        String produtos = "Matéria Prima";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, produtos);
        requisicaoPorServicoPage.addReqProduto();
        requisicaoPorServicoPage.verificarRedProdutoAdd();
        requisicaoPorServicoPage.addSegundaReqProd();
        requisicaoPorServicoPage.verificarSegundoProdutoReqProd();
        requisicaoPorServicoPage.excluirSeguntoProdutoReqProd();
        requisicaoPorServicoPage.alterarValoresProdutoReqProd();
        requisicaoPorServicoPage.excluirReqProduto();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito Jabaquara e o serviço Almoço Especial
    //e selecionar os produtos 'Consumo Fixo', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar no botão adicionar, clicar no campo tipo de prato e selecionar o tipo arroz, clicar no campo prato e selecionar o prato arroz temperado
    //clicar no campo produto e selecionar o produto OLEO DE AMENDOAS DOCES, preencher o campo quantidade extra, preencher o campo quantidade devolvida
    //preencher o campo hora limite, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(tipo de prato, nome tipo de prato, prato, nome do prato) foram salvas corretamente
    //clicar no nome do tipo de prato e verificar se as informações(código, produto, unidade, qtde. prevista, qtde. extra, qtde. devolvida, qtde. liberada, data limite, hora limite) do produto foram salvas corretamente
    //clicar no botão adicionar, clicar no campo produto e selecionar CANFORA, preencher a quantidade extra e quantidade devolvida, selecionar a hora limite, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(código, produto, unidade, qtde. prevista, qtde. extra, qtde. devolvida, qtde. liberada) do segundo produto foram salvas corretamente
    //clicar no check-box do segundo produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto da tela, verificar se a requisição possuí apenas 1 produto
    //alterar os valores da quantidade extra e quantidade devolvida do produto, clicar em salvar alterações, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se após as alterações os valores dos campos (qtde. extra, qtde. devolvida) foram salvos corretamente, e o cálculo da qtde. liberada foi realizado corretamente
    //clicar no check-box do produto, clicar no botão excluir, verificar a mensagem exibida na tela informando que o lançamento deve conter no mínimo 1 produto
    //clicar no botão ok, clicar no botão voltar, clicar no check-box do tipo de prato, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de deletado com sucesso exibida no canto da tela, verificar no grid da lista de tipos de pratos a mensagem de não há registro
    @Test
    public void tipoPratoConsumoFixo() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Tipo de Prato";
        String produtos = "Consumo Fixo";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, produtos);
        requisicaoPorServicoPage.addRequisicaoTipoPrato();
        requisicaoPorServicoPage.verificarReqTipoPratoAdd();
        requisicaoPorServicoPage.addSegundaProdutoReqTipoPrato();
        requisicaoPorServicoPage.verificarSegundaProdutoAddTipoPrato();
        requisicaoPorServicoPage.excluirSegundoProdReqTipoPrato();
        requisicaoPorServicoPage.alterarQuantProdReqTipoPrato();
        requisicaoPorServicoPage.tentarExcluirUnicoProdReqTipoPrato();
        requisicaoPorServicoPage.excluirReTipoPrato();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito BC 111 e o serviço Almoço
    //e selecionar os produtos 'Consumo Fixo', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar no botão adicionar, clicar no campo produto e selecionar o produto CREOSOTO, preencher os campos quantidade extra e quantidade devolvida, preencher o campo hora limite, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(código, produto, unidade, qtde. prevista, qtde.extra, qtde. devolvida, qtde. liberada) do produto foram salvas corretamente
    //clicar no botão adicionar para adicionar um segundo produto, clicar no campo produto e selecionar o produto QUEROSENE, preencher a quantidade extra e quantidade devolvida, preencher o campo hora limite e clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(código, produto, unidade, qtde. prevista, qtde.extra, qtde. devolvida, qtde. liberada) do segundo produto adicionado foram salvas corretamente
    //clicar no check-box do segundo produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem excluída com sucesso exibida no canto da tela, verificar se a requisição passa a ter apenas 1 produto
    //alterar o valores da quantidade extra e quantidade devolvida, clicar no botão salvar alterações, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações dos campos(qtde. extra, qtde. devolvida) foram salvas corretamente e se o cálculo da quantidade liberada foi realizado corretamente
    //clicar no check-box do produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem excluído com sucesso exibida no canto da tela, verificar se no grid da lista de produtos da requisição é apresenta a mensagem não há registros
    @Test
    public void produtoConsumoFixo() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Produto";
        String produtos = "Consumo Fixo";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, produtos);
        requisicaoPorServicoPage.addReqProduto();
        requisicaoPorServicoPage.verificarRedProdutoAdd();
        requisicaoPorServicoPage.addSegundaReqProd();
        requisicaoPorServicoPage.verificarSegundoProdutoReqProd();
        requisicaoPorServicoPage.excluirSeguntoProdutoReqProd();
        requisicaoPorServicoPage.alterarValoresProdutoReqProd();
        requisicaoPorServicoPage.excluirReqProduto();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito Jabaquara e o serviço Almoço Especial
    //e selecionar os produtos 'Consumo Per Capita', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar no botão adicionar, clicar no campo tipo de prato e selecionar o tipo arroz, clicar no campo prato e selecionar o prato arroz temperado
    //clicar no campo produto e selecionar o produto OLEO DE AMENDOAS DOCES, preencher o campo quantidade extra, preencher o campo quantidade devolvida
    //preencher o campo hora limite, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(tipo de prato, nome tipo de prato, prato, nome do prato) foram salvas corretamente
    //clicar no nome do tipo de prato e verificar se as informações(código, produto, unidade, qtde. prevista, qtde. extra, qtde. devolvida, qtde. liberada, data limite, hora limite) do produto foram salvas corretamente
    //clicar no botão adicionar, clicar no campo produto e selecionar CANFORA, preencher a quantidade extra e quantidade devolvida, selecionar a hora limite, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(código, produto, unidade, qtde. prevista, qtde. extra, qtde. devolvida, qtde. liberada) do segundo produto foram salvas corretamente
    //clicar no check-box do segundo produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto da tela, verificar se a requisição possuí apenas 1 produto
    //alterar os valores da quantidade extra e quantidade devolvida do produto, clicar em salvar alterações, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se após as alterações os valores dos campos (qtde. extra, qtde. devolvida) foram salvos corretamente, e o cálculo da qtde. liberada foi realizado corretamente
    //clicar no check-box do produto, clicar no botão excluir, verificar a mensagem exibida na tela informando que o lançamento deve conter no mínimo 1 produto
    //clicar no botão ok, clicar no botão voltar, clicar no check-box do tipo de prato, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de deletado com sucesso exibida no canto da tela, verificar no grid da lista de tipos de pratos a mensagem de não há registro
    @Test
    public void tipoPratoConsumoPerCapita() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Tipo de Prato";
        String produtos = "Consumo Per Capita";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, produtos);
        requisicaoPorServicoPage.addRequisicaoTipoPrato();
        requisicaoPorServicoPage.verificarReqTipoPratoAdd();
        requisicaoPorServicoPage.addSegundaProdutoReqTipoPrato();
        requisicaoPorServicoPage.verificarSegundaProdutoAddTipoPrato();
        requisicaoPorServicoPage.excluirSegundoProdReqTipoPrato();
        requisicaoPorServicoPage.alterarQuantProdReqTipoPrato();
        requisicaoPorServicoPage.tentarExcluirUnicoProdReqTipoPrato();
        requisicaoPorServicoPage.excluirReTipoPrato();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito BC 111 e o serviço Almoço
    //e selecionar os produtos 'Consumo Per Capita', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar no botão adicionar, clicar no campo produto e selecionar o produto CREOSOTO, preencher os campos quantidade extra e quantidade devolvida, preencher o campo hora limite, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(código, produto, unidade, qtde. prevista, qtde.extra, qtde. devolvida, qtde. liberada) do produto foram salvas corretamente
    //clicar no botão adicionar para adicionar um segundo produto, clicar no campo produto e selecionar o produto QUEROSENE, preencher a quantidade extra e quantidade devolvida, preencher o campo hora limite e clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações(código, produto, unidade, qtde. prevista, qtde.extra, qtde. devolvida, qtde. liberada) do segundo produto adicionado foram salvas corretamente
    //clicar no check-box do segundo produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem excluída com sucesso exibida no canto da tela, verificar se a requisição passa a ter apenas 1 produto
    //alterar o valores da quantidade extra e quantidade devolvida, clicar no botão salvar alterações, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se as informações dos campos(qtde. extra, qtde. devolvida) foram salvas corretamente e se o cálculo da quantidade liberada foi realizado corretamente
    //clicar no check-box do produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem excluído com sucesso exibida no canto da tela, verificar se no grid da lista de produtos da requisição é apresenta a mensagem não há registros
    @Test
    public void produtoConsumoPerCapita() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Produto";
        String produtos = "Consumo Per Capita";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, produtos);
        requisicaoPorServicoPage.addReqProduto();
        requisicaoPorServicoPage.verificarRedProdutoAdd();
        requisicaoPorServicoPage.addSegundaReqProd();
        requisicaoPorServicoPage.verificarSegundoProdutoReqProd();
        requisicaoPorServicoPage.excluirSeguntoProdutoReqProd();
        requisicaoPorServicoPage.alterarValoresProdutoReqProd();
        requisicaoPorServicoPage.excluirReqProduto();
    }


    //acessar a tela 'Requisição por Serviço'
    //deixar os campos unidade e data, vazios, clicar em aplicar filtro, verificar a mensagem de campo obrigatório nos campos: unidade, serviço e data
    //atualizar a página, preencher o filtro inicial com a unidade Deposito Jabaquara, serviço Almoço Especial, data 21/08/2022, clicar em aplicar filtro
    //clicar no botão adicionar, clicar no botão do campo data, para deixá-lo vazio, clicar em salvar
    //verificar a mensagem de campo obrigatório nos campos: tipo de prato, prato, produto, data limite e hora limite
    //atualizar a página, preencher o filtro inicial com a unidade Deposito BC 111, serviço Almoço, data 21/08/2022, clicar em aplicar filtro
    //clicar em adicionar, clicar no botão do campos data limite, clicar em salvar
    //verificar a mensagem de campo obrigatório exibida nos campos: produto, data limite e hora limite
    @Test
    public void campoObrigatorios() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String produtos = "Matéria Prima";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.camposObrigatoriosFiltroIni();
        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial("Tipo de Prato", produtos);
        requisicaoPorServicoPage.camposObrigatoriosFormTipoPrato();
        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial("Produto", produtos);
        requisicaoPorServicoPage.camposObrigatoriosFormProduto();
    }


    //acessar a tela 'Requisição por Serviço'
    //verificar se no filtro inicial no campo produtos, são apresentadas as opções: matéria prima, consumo fixo e consumo per capita
    @Test
    public void verificarOpcoesDeProdutosFiltroIni() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.verificarOpcoesProdutos();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito Jabaquara e o serviço Almoço Especial
    //e selecionar os produtos 'Matéria Prima', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar no botão adicionar, clicar no campo tipo de prato e selecionar arroz, clicar no campo prato e selecionar arroz temperado, clicar no campo produto e selecionar OLEO DE AMENDOAS DOCES
    //preencher a quantidade extra com valor 8 e a quantidade devolvida com valor 11, clicar no campo hora limite e verificar se na tela é exibida a mensagem informando a quantidade devolvida deve ser menor ou igual a soma das quantidades prevista e extra.
    //atualizar a página, preencher o filtro inicial com as mesmas informações, alterado apenas o produto para 'Consumo Fixo'
    //tentar adicionar uma requisição preenchendo a quantidade extra e devolvida com os valores 8 e 11 respectivamente, e verificar a mensagem exibida na tela
    //atualizar novamente a página, preencher o filtro inicial com as mesmas informações, alterado apenas o produto para 'Consumo Per Capita'
    //tentar adicionar uma requisição preenchendo a quantidade extra e devolvida com os valores 8 e 11 respectivamente, e verificar a mensagem exibida na tela
    @Test
    public void tentarAddQuantDevolvMaiorQueExtraReqTipoPrato() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Tipo de Prato";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Matéria Prima");
        requisicaoPorServicoPage.quantDevolvidaMaiorReqTipoPrato();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Fixo");
        requisicaoPorServicoPage.quantDevolvidaMaiorReqTipoPrato();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Per Capita");
        requisicaoPorServicoPage.quantDevolvidaMaiorReqTipoPrato();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito BC 111 e o serviço Almoço
    //e selecionar os produtos 'Matéria Prima', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar no botão adicionar, clicar no campo produto e selecionar o produto QUEROSENE
    //preencher a quantidade extra com valor 3, preencher a quantidade devolvida com o valor 8, clicar no botão salvar
    //verificar se na tela é apresentada a mensagem informando que a quantidade devolvida deve ser menor ou igual a soma das quantidades prevista e extra.
    //atualizar a página, preencher o filtro inicial com as mesmas informações, alterado apenas o produto para 'Consumo Fixo'
    //tentar adicionar uma requisição preencher os campos quantidade extra e devolvida com os valores 3 e 8 respectivamente, clicar no campo hora limite e verificar a mensagem apresentada na tela
    //atualizar novamente a página, preencher o filtro inicial com as mesmas informações, alterado apenas o produto para 'Consumo Per Capita'
    //tentar adicionar uma requisição preencher os campos quantidade extra e devolvida com os valores 3 e 8 respectivamente, clicar no campo hora limite e verificar a mensagem apresentada na tela
    @Test
    public void tentarAddQuantDevolvMaiorQueExtraReqProduto() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Produto";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Matéria Prima");
        requisicaoPorServicoPage.quantDevolvidaMaiorReqProd();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Fixo");
        requisicaoPorServicoPage.quantDevolvidaMaiorReqProd();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Per Capita");
        requisicaoPorServicoPage.quantDevolvidaMaiorReqProd();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito BC 111 e o serviço Almoço
    //e selecionar os produtos 'Matéria Prima', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //adicionar uma requisição com o produto CREOSOTO
    //clicar no botão adicionar, clicar no campo produto e selecionar novamente o CREOSOTO, verificar se na tela é apresentando uma mensagem informando que o produto já foi cadastrado
    //clicar em ok, clicar em cancelar, excluir o produto da requisição que foi adicionada com sucesso
    //atualizar a página, preencher o filtro inicial com as mesmas informações, alterando apenas o produto para 'Consumo Fixo'
    //adicionar uma requisição com o produto CREOSOTO
    //clicar no botão adicionar, clicar no campo produto e selecionar novamente o CREOSOTO, verificar se na tela é apresentando uma mensagem informando que o produto já foi cadastrado
    //clicar em ok, clicar em cancelar, excluir o produto da requisição que foi adicionada com sucesso
    //atualizar novamente a página, preencher o filtro inicial com as mesmas informações, alterando apenas o produto para 'Consumo Per Capita'
    //adicionar uma requisição com o produto CREOSOTO
    //clicar no botão adicionar, clicar no campo produto e selecionar novamente o CREOSOTO, verificar se na tela é apresentando uma mensagem informando que o produto já foi cadastrado
    //clicar em ok, clicar em cancelar, excluir o produto da requisição que foi adicionada com sucesso
    @Test
    public void produtoJaCadastradoReqProd() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Produto";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Matéria Prima");
        requisicaoPorServicoPage.addReqProduto();
        requisicaoPorServicoPage.produtoJaCadastradoReqProduto();
        requisicaoPorServicoPage.excluirReqProduto();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Fixo");
        requisicaoPorServicoPage.addReqProduto();
        requisicaoPorServicoPage.produtoJaCadastradoReqProduto();
        requisicaoPorServicoPage.excluirReqProduto();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Per Capita");
        requisicaoPorServicoPage.addReqProduto();
        requisicaoPorServicoPage.produtoJaCadastradoReqProduto();
        requisicaoPorServicoPage.excluirReqProduto();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar unidade Deposito Jabaquara e o serviço Almoço Especial
    //e selecionar o produto 'Matéria Prima', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //adicionar uma requisição com o produto OLEO DE AMENDOAS DOCES
    //clicar no nome do tipo de prato adicionado, clicar em adicionar, clicar no campo produto e selecionar OLEO DE AMENDOAS DOCES
    //verificar a mensagem exibida na tela informando que o produto já foi cadastrado, clicar em ok, clicar em cancelar, clicar em voltar
    //excluir a requisição que foi adicionada com sucesso
    //atualizar a página, preencher o filtro com as mesmas informações, alterando apenas o produto para 'Consumo Fixo'
    //adicionar uma requisição com o produto OLEO DE AMENDOAS DOCES
    //clicar no nome do tipo de prato adicionado, clicar em adicionar, clicar no campo produto e selecionar OLEO DE AMENDOAS DOCES
    //verificar a mensagem exibida na tela informando que o produto já foi cadastrado, clicar em ok, clicar em cancelar, clicar em voltar
    //excluir a requisição que foi adicionada com sucesso
    //atualizar novamente a página, preencher o filtro com as mesmas informações, alterando apenas o produto para 'Consumo Per Capita'
    //adicionar uma requisição com o produto OLEO DE AMENDOAS DOCES
    //clicar no nome do tipo de prato adicionado, clicar em adicionar, clicar no campo produto e selecionar OLEO DE AMENDOAS DOCES
    //verificar a mensagem exibida na tela informando que o produto já foi cadastrado, clicar em ok, clicar em cancelar, clicar em voltar
    //excluir a requisição que foi adicionada com sucesso
    @Test
    public void produtoJaCadastradoReqTipoPrato() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Tipo de Prato";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Matéria Prima");
        requisicaoPorServicoPage.addRequisicaoTipoPrato();
        requisicaoPorServicoPage.produtoJaCadastradoReqTipoPrato();
        requisicaoPorServicoPage.excluirReTipoPrato();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Fixo");
        requisicaoPorServicoPage.addRequisicaoTipoPrato();
        requisicaoPorServicoPage.produtoJaCadastradoReqTipoPrato();
        requisicaoPorServicoPage.excluirReTipoPrato();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Per Capita");
        requisicaoPorServicoPage.addRequisicaoTipoPrato();
        requisicaoPorServicoPage.produtoJaCadastradoReqTipoPrato();
        requisicaoPorServicoPage.excluirReTipoPrato();
    }


    //acessar a tela 'Requisição por Serviço'
    //preencher o filtro inicial, acessar a tela relatório
    //selecionar o primeiro relatório e verificar os campos que estão habilitados
    //após a verificação dos campos habilitado do primeiro relatório, selecionar o segundo relatório e realizar a mesma verificação
    //seguir a verificação dos campos habilitado até concluir a verificação de todos os relatórios
    @Test
    public void camposHabilitados() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.acessarTelaRelatorio();
        requisicaoPorServicoPage.camposHabilitadosTelaRelatorios();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito Jabaquara e o serviço Almoço Especial
    //e selecionar os produtos 'Matéria Prima', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar em 'mensagem', adicionar uma mensagem, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela e verificar se a mensagem foi salva corretamente
    //editar a mensagem, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela e verificar se a mensagem foi salva corretamente
    //deixar o campo mensagem vazio, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela e verificar se o campo mensagem ficou vazio
    //atualizar a página, preencher o filtro inicial com as mesmas informações, alterando apenas o produto para 'Consumo Fixo'
    //realizar as mesmas verificações(adicionar, editar e apagar) no campo mensagem
    //atualizar novamente a página, preencher o filtro inicial com as mesmas informações, alterando apenas o produto para 'Consumo Per Capita'
    //realizar as mesmas verificações(adicionar, editar e apagar) no campo mensagem
    @Test
    public void mensagemReqTipoPrato() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Tipo de Prato";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Matéria Prima");
        requisicaoPorServicoPage.inserirMensagem();
        requisicaoPorServicoPage.editarMensagem();
        requisicaoPorServicoPage.apagarMensagem();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Fixo");
        requisicaoPorServicoPage.inserirMensagem();
        requisicaoPorServicoPage.editarMensagem();
        requisicaoPorServicoPage.apagarMensagem();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Per Capita");
        requisicaoPorServicoPage.inserirMensagem();
        requisicaoPorServicoPage.editarMensagem();
        requisicaoPorServicoPage.apagarMensagem();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito BC 111 e o serviço Almoço
    //e selecionar os produtos 'Matéria Prima', preencher a data 21/08/2022, clicar no botão aplicar filtro
    //clicar em 'mensagem', adicionar uma mensagem, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela e verificar se a mensagem foi salva corretamente
    //editar a mensagem, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela e verificar se a mensagem foi salva corretamente
    //deixar o campo mensagem vazio, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela e verificar se o campo mensagem ficou vazio
    //atualizar a página, preencher o filtro inicial com as mesmas informações, alterando apenas o produto para 'Consumo Fixo'
    //realizar as mesmas verificações(adicionar, editar e apagar) no campo mensagem
    //atualizar novamente a página, preencher o filtro inicial com as mesmas informações, alterando apenas o produto para 'Consumo Per Capita'
    //realizar as mesmas verificações(adicionar, editar e apagar) no campo mensagem
    @Test
    public void mensagemReqProduto() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Produto";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Matéria Prima");
        requisicaoPorServicoPage.inserirMensagem();
        requisicaoPorServicoPage.editarMensagem();
        requisicaoPorServicoPage.apagarMensagem();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Fixo");
        requisicaoPorServicoPage.inserirMensagem();
        requisicaoPorServicoPage.editarMensagem();
        requisicaoPorServicoPage.apagarMensagem();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicial(tipoRequisicao, "Consumo Per Capita");
        requisicaoPorServicoPage.inserirMensagem();
        requisicaoPorServicoPage.editarMensagem();
        requisicaoPorServicoPage.apagarMensagem();
    }


    //acessar a tela 'Requisição por Serviço'
    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito Jabaquara e o serviço Almoço Especial
    //e selecionar os produtos 'Matéria Prima', preencher a data 12/11/2023, clicar no botão aplicar filtro
    //verificar se na tela tem ao menos 1 requisição, caso tenha irá clicar no check-box para selecionar todas as requisições, clicar em excluir
    //verificar a mensagem exibida na tela, clicar em sim, para excluir todas as requisições
    //clicar no botão calcular, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem exibida no canto da tela
    //é passado como parâmetro o tipo de produtos, para que sejam verificadas as informações(código tipo de prato, nome tipo prato, código prato, nome prato) que encontradas após o cálculo
    //após a verificação do tipo prato, clicar no nome do tipo de prato, verificar se na requisição possuí ao menos 1 produtos
    //após a verificação do produtos, clicar em voltar e novamente selecionar todas as requisições, clicar em excluir, verificar a mensagem, clicar em sim
    //atualizar a página, preencher novamente o filtro alterando apenas o produto para Consumo Fixo, excluir as requisições, realizar o cálculo
    //verificar as informações do tipo de prato e do prato, encontrados após o cálculo, verificar se foi encontrado ao menos 1 produto
    //clicar em voltar e excluir todas as requisições
    //atualizar novamente a página, preencher novamente o filtro alterando apenas o produto para Consumo Per Capita, excluir as requisições, realizar o cálculo
    //verificar as informações do tipo de prato e do prato, encontrados após o cálculo, verificar se foi encontrado ao menos 1 produto
    //clicar em voltar e excluir todas as requisições
    @Test
    public void calculoTipoPrato() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Tipo de Prato";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicialParaCalcular(tipoRequisicao, "Matéria Prima");
        requisicaoPorServicoPage.calcularReqTipoPrato("Matéria Prima");
        requisicaoPorServicoPage.excluirTodasReqTipoPrato();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicialParaCalcular(tipoRequisicao, "Consumo Fixo");
        requisicaoPorServicoPage.calcularReqTipoPrato("Consumo Fixo");
        requisicaoPorServicoPage.excluirTodasReqTipoPrato();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicialParaCalcular(tipoRequisicao, "Consumo Per Capita");
        requisicaoPorServicoPage.calcularReqTipoPrato("Consumo Per Capita");
        requisicaoPorServicoPage.excluirTodasReqTipoPrato();
    }


    //acessar a tela 'Requisição por Serviço'
    //no filtro inicial selecionar a unidade Deposito BC 11 e o serviço Almoço
    //e selecionar os produtos 'Matéria Prima', preencher a data 12/11/2023, clicar no botão aplicar filtro
    //verificar se na tela tem ao menos 1 requisição, caso tenha irá clicar no check-box para selecionar todas as requisições, clicar em excluir
    //verificar a mensagem exibida na tela, clicar em sim, para excluir todas as requisições
    //clicar no botão calcular, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem exibida no canto da tela, verificar a mensagem de não há registros exibida no grid da lista de produtos
    //clicar no botão calcular, verificar a mensagem exibida na tela, verificar se após o cálculo é exibido ao menos 1 produto na tela
    //após a verificação do cálculo, clicar no check-box para selecionar todos os produtos, clicar em excluir, verificar a mensagem exibida na tela
    //clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto da tela, verificar a mensagem de não há registro, exibida no grid da lista de produtos
    //atualizar a página, preencher novamente o filtro alterando apenas o produto para Consumo Fixo, excluir as requisições, realizar o cálculo
    //verificar se após o cálculo é exibido ao menos 1 produto na tela, selecionar todos os produtos da tela e excluir os mesmos
    //atualizar novamente a página, preencher novamente o filtro alterando apenas o produto para Consumo Per Capita, excluir as requisições, realizar o cálculo
    //verificar se após o cálculo é exibido ao menos 1 produto na tela, selecionar todos os produtos da tela e excluir os mesmos
    @Test
    public void calculoProduto() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String tipoRequisicao = "Produto";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroInicialParaCalcular(tipoRequisicao, "Matéria Prima");
        requisicaoPorServicoPage.calculoRequisicaoProduto();
        requisicaoPorServicoPage.excluirTodasReqProduto();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicialParaCalcular(tipoRequisicao, "Consumo Fixo");
        requisicaoPorServicoPage.calculoRequisicaoProduto();
        requisicaoPorServicoPage.excluirTodasReqProduto();

        requisicaoPorServicoPage.refresh();
        requisicaoPorServicoPage.preencherFiltroInicialParaCalcular(tipoRequisicao, "Consumo Per Capita");
        requisicaoPorServicoPage.calculoRequisicaoProduto();
        requisicaoPorServicoPage.excluirTodasReqProduto();
    }

    //    relatorioRequisicaoServico = Requisição por Serviço
    //    relatorioTurnos = Requisição por Serviço (Turnos)
    //    relatorioRequisicaoOperador = Requisição por Operador
    //    relatorioServicoPontoEntrega = Requisição por Serviço/Ponto de Entrega (Analítico)
    //    relatorioGrupoServicoSintetico = Requisição por Grupo de Serviço (Sintético)
    //    relatorioTipoPrato = Requisição por Serviço (Tipo de Prato/Prato)
    //    relatorioUnidadeAdicional = Requisição por Serviço (Unidade Adicional)

    @Test
    public void relatorioRequisicaoServico() {
        gerarRelatorio("Requisição por Serviço");
    }

    @Test
    public void relatorioTurnos() {
        gerarRelatorio("Requisição por Serviço (Turnos)");
    }

    @Test
    public void relatorioRequisicaoOperador() {
        gerarRelatorio("Requisição por Operador");
    }

    @Test
    public void relatorioServicoPontoEntrega() {
        gerarRelatorio("Requisição por Serviço/Ponto de Entrega (Analítico)");
    }

    @Test
    public void relatorioGrupoServicoSintetico() {
        gerarRelatorio("Requisição por Grupo de Serviço (Sintético)");
    }

    @Test
    public void relatorioTipoPrato() {
        gerarRelatorio("Requisição por Serviço (Tipo de Prato/Prato)");
    }

    @Test
    public void relatorioUnidadeAdicional() {
        gerarRelatorio("Requisição por Serviço (Unidade Adicional)");
    }


    //acessar a tela 'Requisição por Serviço'
    //preencher o filtro inicial, acessar a tela relatório
    //selecionar o relatório que foi passado como parâmetro
    //preencher as datas inicial e final, selecionar unidade, clicar no botão relatório, pdf e confirmar
    //fechar a guia do relatório que foi aberta
    //clicar em 'Todos' do campo grupo de serviço, clicar no campo grupo de serviço, selecionar 3 grupos e clicar em ok
    //clicar em 'Todos' do campo serviço, clicar no campo grupo de serviço, selecionar 2 serviços e clicar em ok
    //caso o relatório passado como parâmetro seja o "Requisição por Serviço/Ponto de Entrega (Analítico)", irá clicar no 'Todos' do campo ponto de entrega, clicar no campo ponto de entrega, selecionar 1 ponto e clicar em ok
    //clicar em 'Todos' do campo Tipos de Consumo (Calcular / Imprimir), clicar no campo Tipos de Consumo (Calcular / Imprimir), selecionar 1 tipo e clicar em ok
    //clicar no botão relatório, pdf e confirmar, fechar a guia do relatório que foi aberta
    public void gerarRelatorio(String nomeRelatorio) {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/07/2022";
        String dataFinal = "31/10/2022";

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateTelaRequisicaoPorServico();
        requisicaoPorServicoPage.acessarTelaRelatorio();
        requisicaoPorServicoPage.selecionarRelatorio(nomeRelatorio);
        requisicaoPorServicoPage.preencherDatas(dataInicial, dataFinal);
        requisicaoPorServicoPage.selecionarUnidade();
        requisicaoPorServicoPage.gerarRelatorio();
        requisicaoPorServicoPage.selecionarGrupoServicos();
        requisicaoPorServicoPage.selecionarServico();

        if (nomeRelatorio.equals("Requisição por Serviço/Ponto de Entrega (Analítico)")) {
            requisicaoPorServicoPage.selecionarPontoDeEntrega();
        }

        requisicaoPorServicoPage.selecionarTipoDeConsumo();
        requisicaoPorServicoPage.gerarRelatorio();
    }




}