package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RetiradaPlanejamentoFlows;
import com.javaseleniumtemplate.pages.RetiradaPlanejamentoPage;
import org.testng.annotations.Test;

public class RetiradaPlanejamentoTests extends TestBase {

    RetiradaPlanejamentoPage retiradaPlanejamentoPage;
    RetiradaPlanejamentoFlows retiradaPlanejamentoFlows;
    LoginFlows loginFlows;


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito Jabaquara, clicar no campo serviço e selecionar o serviço Almoço Especial
    //preencher o campo data com a data 09/03/2023, clicar no botão aplicar filtro
    //verificar a mensagem exibida na tela informando que não existe retirada, clicar em sim, verificar as informações(serviço, data retirada, data cardápio) do filtro nova retirada
    //clicar no campo tipo de prato e selecionar o tipo GUARNIÇÃO, clicar no campo prato e selecionar o prato STROGONOFF TRANSPORTADA, clicar no campo produto e selecionar o produto OLEO DE COPAIBA
    //preencher o campos qt extra e qt devolvida
    //clicar no campo tipo de retirada, selecionar o tipo CONSUMO DE EMPRESA, clicar no botão salvar
    //clicar no campo almoxarifado e selecionar o MATERIA PRIMA APROVADO, clicar no campo lote e selecionar o lote do produto OLEO DE COPAIBA
    //clicar no botão confirmar, verificar a mensagem de sucesso exibida na tela, clicar em ok
    //atualizar a página, preencher novamente o filtro com as mesmas informações que foram preenchidas no início do teste
    //verificar se as informações(código do tipo de prato, nome do tipo de prato, código do prato, nome do prato) foram salvas corretamente
    //clicar no nome do prato, verificar se as informações(código do produto, nome, unidade, qt prevista, qt extra, qt devolvida, qt consumida, valor unitário,tipo retirada, status, almoxarifado, localização, lote), clicar em voltar
    //verificar se o custo total apresentado no cabeçalho da página, foi calculado corretamente, multiplicando a quantidade consumida com o valor unitário do produto
    //clicar no check-box do tipo de prato, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem de excluído com sucesso, clicar em ok
    //preencher novamente o filtro inicial com as mesmas informações que foram informadas no início do teste, verificar se a informação de que não existe retirada é exibida na tela
    @Test
    public void teste1() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Tipo de Prato";
        String data = "09/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
        retiradaPlanejamentoPage.confirmarFiltroNovaRetirada(tipoRetirada, data);
        retiradaPlanejamentoPage.adicionarRetTipoPratoGuarnicaoProdOleoCopaiba();
        retiradaPlanejamentoPage.refresh();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.verificarRetTipoPratoGuarnicaoProdOleoCopaiba();
        retiradaPlanejamentoPage.verificarProdutoRetTipoPratoGuarnicaoProdOleoCopaiba();
        retiradaPlanejamentoPage.verificarCustoTotalAposAddRetTipoPrato();
        retiradaPlanejamentoPage.excluirRetiradaTipoPrato();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito Jabaquara, clicar no campo serviço e selecionar o serviço Almoço Especial
    //preencher o campo data com a data 08/03/2023, clicar no botão aplicar filtro, acessando uma data que já possuí retirada
    //clicar no nome do prato, alterar o valor da quantidade extra do produto pelo inline, selecionar o almoxarifado e o lote do produto alterado, clicar em confirmar
    //alterar a quantidade devolvida do produto pela inline, selecionar o almoxarifado e o lote do produto, clicar em confirmar, clicar em salvar as alterações, verificar a mensagem exibida na tela e clicar em ok
    //verificar se as quantidades(prevista, extra, devolvida, consumida) foram salvas corretamente, e verificar se o custo total foi recalculado corretamente após a alteração das quantidades
    //alterar novamente a quantidade devolvida pelo inline, retornando para a quantidade que estava no início do teste, selecionar o almoxarifado e lote do produto alterado, clicar em confirmar
    //alterar novamente a quantidade extra, pelo inline retornando para a quantidade que estava no início do teste, selecionar o almoxarifado e lote do produto, clicar em confirmar
    //clicar em salvar alterações, verificar a mensagem de sucesso exibida na tela, clicar em ok
    //verificar se as quantidades(prevista, extra, devolvida, consumida) foram salvas corretamente, e verificar se o custo total foi recalculado corretamente após a alteração das quantidades
    @Test
    public void teste2() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Tipo de Prato";
        String data = "08/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.editarQuntidadeProdutoPeloInLine(); //realizar primeira alteração nas quantidades
        retiradaPlanejamentoPage.verificarQuantidadesAposEdicaoInLine(1); // verificar os valores após a primeira alteração
        retiradaPlanejamentoPage.editarQuntidadeProdutoPeloInLineReturnValoresIniciais(); //realizar segunda alteração nas quantidades, retornando para os valores do início do teste
        retiradaPlanejamentoPage.verificarQuantidadesAposEdicaoInLine(2); // verificar os valores após a segunda alteração, para retornar os valores iniciais do teste
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito Jabaquara, clicar no campo serviço e selecionar o serviço Almoço Especial
    //preencher o campo data com a data 07/03/2023, clicar no botão aplicar filtro, acessando uma data que já possuí retirada
    //clicar no nome do prato, clicar em adicionar, clicar no botão do campo produto, procurar pelo produto POTE DE VIDRO AMBAR e selecionar o mesmo
    //preencher as quantidades extra e devolvida, clicar em salvar, selecionar o almoxarifado e lote do produto adicionado, clicar em confirmar, verificar a mensagem de sucesso exibida na tela, clicar em ok
    //verificar se a retirada passa a ter 2 produtos
    //verificar se as informações(código do produto, nome, unidade, qt prevista, qt extra, qt devolvida, qt consumida, valor unitário,tipo retirada, status, almoxarifado, localização, lote) do segundo produto foram salvas corretamente
    //clicar em voltar, verificar se o custo total foi recalculado corretamente após adicionar o segundo produto à retirada
    //clicar no nome do tipo de prato, clicar no check-box do segundo produto, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida na tela, clicar em ok, verificar se a retirada voltou a ter apenas 1 produto
    @Test
    public void teste3() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Tipo de Prato";
        String data = "07/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.adicionarSegundoProdutoRetTipoPrato();
        retiradaPlanejamentoPage.verificarSegundoProdutoAddRqtTipoPrato();
        retiradaPlanejamentoPage.excluirSegundoProdutoRetTipoPrato();
        retiradaPlanejamentoPage.tentarLancarQuantDevolMaiorQueExtra();
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito Jabaquara, clicar no campo serviço e selecionar o serviço Almoço Especial
    //preencher o campo data com a data 15/03/2023, clicar no botão aplicar filtro, acessando uma data que já possuí retirada com quantidade prevista
    //alterar a quantidade devolvida do segundo produto por meio do inline, selecionar o almoxarifado e lote do produto alterado, clicar em confirmar
    //clicar no botão salvar alterações, clicar em ok, verificar se os valores(qt prevista, qt extra, qt devolvida, qt consumida) foram salvas corretamente após a alteração
    //alterar a quantidade consumida por meio do inline, retornando a quantidade para o valor que estava no início do teste, selecionar o almoxarifado e lote do produto alterado, clicar em confirmar
    //clicar no botão salvar alterações, clicar em ok, verificar se os valores(qt prevista, qt extra, qt devolvida, qt consumida) foram salvas corretamente após a alteração
    //verificar se as informações(qt prevista, qt extra, qt devolvida, qt consumida) foram salvas corretamente
    //alterar a quantidade devolvida do primeiro produto, inserindo um valor maior que a quantidade prevista, verificar a mensagem exibida na tela, clicar em ok
    //verificar se as informações(qt prevista, qt extra, qt devolvida, qt consumida) não foram alteradas
    @Test
    public void teste4() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Tipo de Prato";
        String data = "15/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.editarQuantDevolProdComQuantPrevista();
        retiradaPlanejamentoPage.tentarLancarQuantDevolMaiorQueReqEmProdQuantPrevista();
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito Jabaquara, clicar no campo serviço e selecionar o serviço Almoço Especial
    //preencher o campo data com a data 02/03/2023, clicar no botão aplicar filtro
    //verificar a mensagem exibida na tela informando que não existe retirada, clicar em sim, verificar as informações(serviço, data retirada, data cardápio) do filtro nova retirada, clicar em confirmar
    //clicar no campo tipo de prato e selecionar o tipo GUARNIÇÃO, clicar no campo prato e selecionar o prato STROGONOFF TRANSPORTADA, clicar no campo produto, procurar pelo produto CAIXA DE PAPELAO NATUBABY e selecionar o mesmo
    //preencher o campos qt extra, clicar no botão salvar, selecionar o almoxarifado e lote do produto, clicar em confirmar
    //verificar a mensagem exibida na tela informando que a quantidade informado do produto é mais que a disponível em estoque
    //clicar no botão ok
    @Test
    public void teste5() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Tipo de Prato";
        String data = "02/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
        retiradaPlanejamentoPage.confirmarFiltroNovaRetirada(tipoRetirada, data);
        retiradaPlanejamentoPage.tentarInserirQuantMaiorQueSaldoEstoqRetTipoPrato();
    }


    ////////////////////
    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito BC 111, clicar no campo serviço e selecionar o serviço Almoço
    //preencher o campo data com a data 23/03/2023, clicar no botão aplicar filtro
    //verificar a mensagem exibida na tela informando que não existe retirada, clicar em sim, verificar as informações(serviço, data retirada, data cardápio) do filtro nova retirada
    //clicar no botão do campo produto, procurar pelo produto BISSULFATO DE POTASSIO e selecionar o mesmo, preencher o campo quantidade extra, clicar no campo tipo de retirada e selecionar CONSUMO DE PRODUÇÃO
    //clicar em salvar, selecionar o almoxarifado e lote do produto, clicar em confirmar, verificar a mensagem de sucesso exibida na tela, clicar em ok
    //verificar se as informações(código do produto, nome, unidade, qt prevista, qt extra, qt devolvida, qt consumida, valor unitário, tipo retirada, status, almoxarifado, localização, lote) foram salvas corretamente
    //verificar se o custo total da retirada foi calculado corretamente, clicar no check-box do produto, clicar no botão excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida na tela, clicar em ok
    //atualizar a página, preencher o filtro inicial com as mesmas informações que foram preenchidas no início do teste, clicar em aplicar filtro, verificar se é apresentada a mensagem informando que não existe retirada
    @Test
    public void teste6() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Produto";
        String data = "23/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
        retiradaPlanejamentoPage.confirmarFiltroNovaRetirada(tipoRetirada, data);
        retiradaPlanejamentoPage.adicionarRetProdutoBissulfatoPotassio();
        retiradaPlanejamentoPage.verificarRetProdutoBissulfatoPotassio();
        retiradaPlanejamentoPage.verificarCustoTotalAposAdicionarRetiradaProduto();
        retiradaPlanejamentoPage.excluirRetProduto();
        retiradaPlanejamentoPage.refresh();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito BC 111, clicar no campo serviço e selecionar o serviço Almoço
    //preencher o campo data com a data 23/03/2023, clicar no botão aplicar filtro, acessando uma data que já possuí retirada de produto
    //clicar no botão adicionar, clicar no botão do campo produto, procurar pelo produto CANFORA e selecionar o mesmo, preencher os campos quantidade extra e quantidade devolvida
    //clicar em salvar, selecionar o almoxarifado e o lote do produto informado, clicar em confirmar, verificar a mensagem de sucesso exibida na tela, clicar em ok
    //verificar se as informações(código do produto, nome, unidade, qt prevista, qt extra, qt devolvida, qt consumida, valor unitário, tipo retirada, status, almoxarifado, localização, lote) foram salvas corretamente
    //verificar se o custo total foi recalculado corretamente, levando em consideração os 2 produtos da retirada
    //clicar no check-box do segundo produto, clicar no botão excluir, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem de excluído com sucesso exibida na tela, clicar em ok
    //verificar se a retirada volta a ter apenas 1 produto
    //alterar a quantidade devolvida do primeiro produto pelo inline, inserindo uma quantidade maior que a extra, verificar a mensagem exibida na tela, clicar em ok e verificar se a quantidade não foi alterada
    @Test
    public void teste7() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Produto";
        String data = "22/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.adicionarSeguntoProdRetProduto();
        retiradaPlanejamentoPage.verificarSegundoProdRetProduto();
        retiradaPlanejamentoPage.verificarCustoTotoalAposAddSegundoProdRetProduto();
        retiradaPlanejamentoPage.excluirSegundoProdRetProduto();
        retiradaPlanejamentoPage.tentarLancarQuantDevolvidaMaiorQueExtraRetProduto();
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito BC 111, clicar no campo serviço e selecionar o serviço Almoço
    //preencher o campo data com a data 21/03/2023, clicar no botão aplicar filtro, acessando uma data que já possui retirada
    //alterar a quantidade extra do produto por meio do inline, selecionar o almoxarifado e a quantidade extra do produto, clicar em confirmar
    //alterar a quantidade devolvida do produto por meio do inline, selecionar o almoxarifado e a quantidade extra do produto, clicar em confirmar
    //clicar em salvar alterações, verificar a mensagem de sucesso exibida na tela, clicar em ok
    //verificar se as quantidades(prevista, extra, devolvida e consumida) foram salvas corretamente
    //alterar a quantidade extra por meio do inline, retornando para o valor que estava no início do teste, selecionar o almoxarifado e o lote do produto, clicar em confirmar
    //alterar a quantidade devolvida por meio do inline, retornando para o valor que estava no início do teste, selecionar o almoxarifado e o lote do produto, clicar em confirmar
    //clicar em salvar alterações, verificar a mensagem de sucesso exibida na tela, clicar em ok
    //verificar se as quantidades(prevista, extra, devolvida e consumida) foram salvas corretamente
    @Test
    public void teste8() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Produto";
        String data = "21/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.alterarQuantidadeRetProdutoInLine(); //realizar a primeira alteração das quantidades (extra, devolvida) no produto
        retiradaPlanejamentoPage.verificarQuantAlteradaRetProduto(1); // verificar as quantidades após a primeira alteração
        retiradaPlanejamentoPage.retornarQuantIniProdRetProduto(); // realizar a segunda alteração nas quantidade, retornando para os valores que estavam no início do teste
        retiradaPlanejamentoPage.verificarQuantAlteradaRetProduto(2); //verificar os valores das quantidade após a segunda alteração, em que os mesmo retornaram para o valores que estavam no início do teste
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito BC 111, clicar no campo serviço e selecionar o serviço Almoço
    //preencher o campo data com a data 20/03/2023, clicar no botão aplicar filtro, acessando uma data que já possui retirada com quantidade prevista
    //alterar a quantidade devolvida do segundo produto por meio do inline, selecionar o almoxarifado e o lote do produto, clicar em confirmar
    //clicar no botão salvar alterações, verificar a mensagem de sucesso exibida na tela, clicar em ok
    //verificar se as quantidades(prevista, extra, devolvida e consumida) foram salvas corretamente
    //alterar novamente a quantidade devolvida do segundo produto por meio do inline, retornando o valor que o que estava no início do teste, selecionar o almoxarifado e lote do produto, clicar em confirmar
    //clicar no botão salvar alterações, verificar a mensagem de sucesso exibida na tela, clicar em ok
    //verificar se as quantidades(prevista, extra, devolvida e consumida) foram salvas corretamente
    //alterar a quantidade devolvida do primeiro produto inserindo um valor mais que a quantidade prevista, verificar a mensagem exibida na tela
    //clicar em ok, verificar se a quantidade devolvida do produto não foi alterada
    @Test
    public void teste9() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Produto";
        String data = "20/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.editarQuantDevolvidaRetProdutoComQuantPrevista();
        retiradaPlanejamentoPage.tentarLancarQuantDevolvidaMaiorQueReqRetProduto();
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito BC 111, clicar no campo serviço e selecionar o serviço Almoço
    //preencher o campo data com a data 02/03/2023, clicar no botão aplicar filtro
    //verificar a mensagem exibida na tela informando que não existe retirada, clicar em sim, verificar as informações(serviço, data retirada, data cardápio) do filtro nova retirada
    //clicar no botão do campo produto, procurar pelo produto BISSULFATO DE POTASSIO e selecionar o mesmo, preencher o campo quantidade extra
    //clicar em salvar, selecionar o almoxarifado e lote do produto, clicar em confirmar, verificar a mensagem exibida na tela informando que a quantidade informado do produto é mais que a disponível em estoque
    //clicar no botão ok
    @Test
    public void teste10() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoRetirada = "Produto";
        String data = "02/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoRetirada, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
        retiradaPlanejamentoPage.confirmarFiltroNovaRetirada(tipoRetirada, data);
        retiradaPlanejamentoPage.tentarInserirQuantMaiorQueSaldoEstoq();
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial, clicar no botão do campo unidade, clicar no botão do campo data, clicar no botão aplicar filtro
    //verificar a mensagem de campo obrigatório nos campos: unidade, serviço, data retirada e data cardápio
    //atualizar a página, no filtro inicial selecionar a unidade Deposito Jabaquara, serviço Almoço Especial, preencher a data 01/03/2023, clicar em aplicar filtro
    //verificar a mensagem informando que não há registro, clicar em sim, confirmar o filtro da nova retirada
    //no formulário para adicionar um retirada de tipo de prato, dar um duplo clique nos campos quantidade extra, quantidade devolvida, quantidade consumida, clicar no botão do campo tipo de retirada, para deixar todos vazios
    //clicar no botão salvar e verificar a mensagem de campo obrigatório nos campos: tipo prato, prato, produto, quantidade extra, quantidade devolvida, quantidade consumida e tipo de retirada
    //atualizar a página, no filtro inicial selecionar a unidade Deposito Jabaquara, serviço Almoço Especial, preencher a data 01/03/2023, clicar em aplicar filtro
    //verificar a mensagem informando que não há registro, clicar em sim, confirmar o filtro da nova retirada
    //preencher o formulário para adicionar uma retirada de tipo de prato, informando o tipo de prato, o prato, o produto, a quantidade extra, o tipo de retirada, clicar em salvar
    //clicar no botão do campo almoxarifado para deixá-lo vazio, clicar em confirmar e verificar a mensagem de campo obrigatório nos campos almoxarifado e lote
    //atualizar a página, no filtro inicial selecionar a unidade Deposito BC 111, serviço Almoço, preencher a data 01/03/2023, clicar em aplicar filtro
    //verificar a mensagem informando que não há registro, clicar em sim, confirmar o filtro da nova retirada
    //no formulário para adicionar uma retirada de produto, dar um duplo clique nos campos quantidade extra, quantidade devolvida e quantidade consumida, para deixá-los vazios, clicar no botão do campo tipo de retirada
    //verificar a mensagem de campo obrigatório nos campos: produto, quantidade extra, quantidade devolvida, quantidade consumida e tipo de retirada
    //atualizar a página, no filtro inicial selecionar a unidade Deposito BC 111, serviço Almoço, preencher a data 01/03/2023, clicar em aplicar filtro
    //verificar a mensagem informando que não há registro, clicar em sim, confirmar o filtro da nova retirada
    //preencher o formulário para adicionar uma retirada de produto, informando o produto, a quantidade extra, clicar em salvar
    //clicar no botão do campo almoxarifado para deixá-lo vazio, clicar em confirmar e verificar a mensagem de campo obrigatório nos campos almoxarifado e lote
    @Test
    public void teste11() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String tipoPrato = "Tipo de Prato";
        String produto = "Produto";
        String data = "01/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.camposObrigatoriosFiltroIni();

        retiradaPlanejamentoPage.refresh();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoPrato, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
        retiradaPlanejamentoPage.confirmarFiltroNovaRetirada(tipoPrato, data);
        retiradaPlanejamentoPage.camposObrigatoriosFormRetTipoPrato();
        retiradaPlanejamentoPage.refresh();
        retiradaPlanejamentoPage.preencherFiltroInicial(tipoPrato, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
        retiradaPlanejamentoPage.confirmarFiltroNovaRetirada(tipoPrato, data);
        retiradaPlanejamentoPage.camposObrigatoriosInformacoesProdRetTipoPrato();

        retiradaPlanejamentoPage.refresh();
        retiradaPlanejamentoPage.preencherFiltroInicial(produto, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
        retiradaPlanejamentoPage.confirmarFiltroNovaRetirada(produto, data);
        retiradaPlanejamentoPage.camposObrigatoriosFormRetProduto();
        retiradaPlanejamentoPage.refresh();
        retiradaPlanejamentoPage.preencherFiltroInicial(produto, data);
        retiradaPlanejamentoPage.alertaNaoExisteRetirada();
        retiradaPlanejamentoPage.confirmarFiltroNovaRetirada(produto, data);
        retiradaPlanejamentoPage.camposObrigatoriosInformacaoProdRetProduto();
    }


    //acessar a tela Retirada (Planejamento)
    //no filtro inicial clicar no campo unidade e selecionar a unidade Deposito Jabaquara, clicar no campo serviço e selecionar o serviço Almoço Especial
    //preencher o campo data com a data 01/03/2023, clicar no botão aplicar filtro, acessando uma data que já possui retirada com quantidade prevista
    //clicar no botão ações, clicar na ação Exibir Resumo, verificar as informações (código, nome, unidade, quant. prevista, quant. extra, quant. devolvida, quant. consumida, custo, quant. estoque) de uma retirada de tipo de prato apresentadas na tela
    //clicar no botão ações, clicar na ação atualizar estoque, verificar a mensagem de sucesso exibida na tela e clicar em ok
    //clicar no botão ações, clicar na ação exibir romaneio, preencher as data 'de' e 'até', clicar em filtrar, verificar se as informações (serviço, nome, dt retirada, dt cardápio, nr requisição e nr lançamento) estão corretas, clicar em voltar e clicar em cancelar
    //atualizar a página, no filtro inicial clicar no campo unidade e selecionar a unidade Deposito BC 111, clicar no campo serviço e selecionar o serviço Almoço
    //clicar no botão ações, clicar na ação Exibir Resumo, verificar as informações (código, nome, unidade, quant. prevista, quant. extra, quant. devolvida, quant. consumida, custo, quant. estoque) de uma retirada de produto apresentadas na tela
    //clicar no botão ações, clicar na ação atualizar estoque, verificar a mensagem de sucesso exibida na tela e clicar em ok
    //clicar no botão ações, clicar na ação exibir romaneio, preencher as data 'de' e 'até', clicar em filtrar, verificar se as informações (serviço, nome, dt retirada, dt cardápio, nr requisição e nr lançamento) estão corretas, clicar em voltar e clicar em cancelar
    @Test
    public void teste12() {
        retiradaPlanejamentoPage = new RetiradaPlanejamentoPage();
        retiradaPlanejamentoFlows = new RetiradaPlanejamentoFlows();
        loginFlows = new LoginFlows();

        String retiradaTipoPrato = "Tipo de Prato";
        String retiradaProduto = "Produto";
        String data = "03/03/2023";

        loginFlows.efetuarLogin();
        retiradaPlanejamentoFlows.navegateTelaRetiradaPlanejamento();
        retiradaPlanejamentoPage.preencherFiltroInicial(retiradaTipoPrato, data);
        retiradaPlanejamentoPage.testeAcaoExibirResumo(retiradaTipoPrato);
        retiradaPlanejamentoPage.testeAcaoAtualizarEstoque();
        retiradaPlanejamentoPage.testeAcaoRomaneio(retiradaTipoPrato);

        retiradaPlanejamentoPage.refresh();
        retiradaPlanejamentoPage.preencherFiltroInicial(retiradaProduto, data);
        retiradaPlanejamentoPage.testeAcaoExibirResumo(retiradaProduto);
        retiradaPlanejamentoPage.testeAcaoAtualizarEstoque();
        retiradaPlanejamentoPage.testeAcaoRomaneio(retiradaProduto);
    }


}